#define GC_VARIABLE_STACK GC_variable_stack
#define GET_GC_VARIABLE_STACK() GC_VARIABLE_STACK
#define SET_GC_VARIABLE_STACK(v) (GC_VARIABLE_STACK = (v))
#define PREPARE_VAR_STACK(size) void *__gc_var_stack__[size+2]; __gc_var_stack__[0] = GET_GC_VARIABLE_STACK(); SET_GC_VARIABLE_STACK(__gc_var_stack__);
#define PREPARE_VAR_STACK_ONCE(size) PREPARE_VAR_STACK(size); __gc_var_stack__[1] = (void *)size;
#define SETUP(x) (__gc_var_stack__[1] = (void *)x)
#ifdef MZ_3M_CHECK_VAR_STACK
static int _bad_var_stack_() { *(long *)0x0 = 1; return 0; }
# define CHECK_GC_V_S ((GC_VARIABLE_STACK == __gc_var_stack__) ? 0 : _bad_var_stack_()),
#else
# define CHECK_GC_V_S /*empty*/
#endif
#define FUNCCALL_each(setup, x) (CHECK_GC_V_S setup, x)
#define FUNCCALL_EMPTY_each(x) (SET_GC_VARIABLE_STACK((void **)__gc_var_stack__[0]), x)
#define FUNCCALL_AGAIN_each(x) (CHECK_GC_V_S x)
#define FUNCCALL_once(setup, x) FUNCCALL_AGAIN_each(x)
#define FUNCCALL_EMPTY_once(x) FUNCCALL_EMPTY_each(x)
#define FUNCCALL_AGAIN_once(x) FUNCCALL_AGAIN_each(x)
#define PUSH(v, x) (__gc_var_stack__[x+2] = (void *)&(v))
#define PUSHARRAY(v, l, x) (__gc_var_stack__[x+2] = (void *)0, __gc_var_stack__[x+3] = (void *)&(v), __gc_var_stack__[x+4] = (void *)l)
#define BLOCK_SETUP_TOP(x) x
#define BLOCK_SETUP_each(x) BLOCK_SETUP_TOP(x)
#define BLOCK_SETUP_once(x) /* no effect */
#define RET_VALUE_START return (__ret__val__ = 
#define RET_VALUE_END , SET_GC_VARIABLE_STACK((void **)__gc_var_stack__[0]), __ret__val__)
#define RET_VALUE_EMPTY_START return
#define RET_VALUE_EMPTY_END 
#define RET_NOTHING { SET_GC_VARIABLE_STACK((void **)__gc_var_stack__[0]); return; }
#define RET_NOTHING_AT_END RET_NOTHING
#define DECL_RET_SAVE(type) type __ret__val__;
#define NULLED_OUT 0
#define NULL_OUT_ARRAY(a) memset(a, 0, sizeof(a))
#define GC_CAN_IGNORE /**/
#define __xform_nongcing__ /**/
#define HIDE_FROM_XFORM(x) x
#define XFORM_HIDE_EXPR(x) x
#define HIDE_NOTHING_FROM_XFORM() /**/
#define START_XFORM_SKIP /**/
#define END_XFORM_SKIP /**/
#define START_XFORM_SUSPEND /**/
#define END_XFORM_SUSPEND /**/
#define XFORM_START_SKIP /**/
#define XFORM_END_SKIP /**/
#define XFORM_START_SUSPEND /**/
#define XFORM_END_SUSPEND /**/
#define XFORM_OK_PLUS +
#define XFORM_OK_MINUS -
#define XFORM_TRUST_PLUS +
#define XFORM_TRUST_MINUS -

#define NEW_OBJ(t) new (UseGC) t
#define NEW_ARRAY(t, array) (new (UseGC) t array)
#define NEW_ATOM(t) (new (AtomicGC) t)
#define NEW_PTR(t) (new (UseGC) t)
#define NEW_ATOM_ARRAY(t, array) (new (AtomicGC) t array)
#define NEW_PTR_ARRAY(t, array) (new (UseGC) t* array)
#define DELETE(x) (delete x)
#define DELETE_ARRAY(x) (delete[] x)
#define XFORM_RESET_VAR_STACK /* empty */

extern "C" {
  typedef unsigned char __u_char ; 
  typedef unsigned short int __u_short ; 
  typedef unsigned int __u_int ; 
  typedef unsigned long int __u_long ; 
  __extension__ typedef long long int __quad_t ; 
  __extension__ typedef unsigned long long int __u_quad_t ; 
  __extension__ typedef __u_quad_t __dev_t ; 
  __extension__ typedef unsigned int __uid_t ; 
  __extension__ typedef unsigned int __gid_t ; 
  __extension__ typedef unsigned long int __ino_t ; 
  __extension__ typedef __u_quad_t __ino64_t ; 
  __extension__ typedef unsigned int __mode_t ; 
  __extension__ typedef unsigned int __nlink_t ; 
  __extension__ typedef long int __off_t ; 
  __extension__ typedef __quad_t __off64_t ; 
  __extension__ typedef int __pid_t ; 
  __extension__ typedef struct {
    int __val [2 ] ; 
  }
  __fsid_t ; 
  __extension__ typedef long int __clock_t ; 
  __extension__ typedef unsigned int __id_t ; 
  __extension__ typedef long int __time_t ; 
  __extension__ typedef unsigned int __useconds_t ; 
  __extension__ typedef long int __suseconds_t ; 
  __extension__ typedef int __daddr_t ; 
  __extension__ typedef int __key_t ; 
  __extension__ typedef int __clockid_t ; 
  __extension__ typedef void * __timer_t ; 
  __extension__ typedef long int __blksize_t ; 
  __extension__ typedef long int __blkcnt_t ; 
  __extension__ typedef __quad_t __blkcnt64_t ; 
  __extension__ typedef unsigned long int __fsblkcnt_t ; 
  __extension__ typedef __u_quad_t __fsblkcnt64_t ; 
  __extension__ typedef unsigned long int __fsfilcnt_t ; 
  __extension__ typedef __u_quad_t __fsfilcnt64_t ; 
  __extension__ typedef int __ssize_t ; 
  typedef __off64_t __loff_t ; 
  typedef char * __caddr_t ; 
  typedef unsigned int size_t ; 
  typedef int int8_t __attribute__ ((__mode__ (__QI__ ) ) ) ; 
  typedef int int16_t __attribute__ ((__mode__ (__HI__ ) ) ) ; 
  typedef int int32_t __attribute__ ((__mode__ (__SI__ ) ) ) ; 
  typedef int int64_t __attribute__ ((__mode__ (__DI__ ) ) ) ; 
  typedef unsigned int u_int8_t __attribute__ ((__mode__ (__QI__ ) ) ) ; 
  typedef unsigned int u_int16_t __attribute__ ((__mode__ (__HI__ ) ) ) ; 
  typedef unsigned int u_int32_t __attribute__ ((__mode__ (__SI__ ) ) ) ; 
  typedef unsigned int u_int64_t __attribute__ ((__mode__ (__DI__ ) ) ) ; 
  typedef int register_t __attribute__ ((__mode__ (__word__ ) ) ) ; 
  typedef struct {
    unsigned long int __val [(1024 / (8 * sizeof (unsigned long int ) ) ) ] ; 
  }
  __sigset_t ; 
  struct timespec {
    __time_t tv_sec ; 
    long int tv_nsec ; 
  }
  ; 
  struct timeval {
    __time_t tv_sec ; 
    __suseconds_t tv_usec ; 
  }
  ; 
  typedef long int __fd_mask ; 
  typedef struct {
    __fd_mask fds_bits [1024 / (8 * sizeof (__fd_mask ) ) ] ; 
  }
  fd_set ; 
  extern "C" {
  }
  typedef union {
    char __size [36 ] ; 
    long int __align ; 
  }
  pthread_attr_t ; 
  typedef struct __pthread_internal_slist {
    struct __pthread_internal_slist * __next ; 
  }
  __pthread_slist_t ; 
  typedef union {
    struct __pthread_mutex_s {
      int __lock ; 
      unsigned int __count ; 
      int __owner ; 
      int __kind ; 
      unsigned int __nusers ; 
      __extension__ union {
        int __spins ; 
        __pthread_slist_t __list ; 
      }
      ; 
    }
    __data ; 
    char __size [24 ] ; 
    long int __align ; 
  }
  pthread_mutex_t ; 
  typedef union {
    char __size [4 ] ; 
    long int __align ; 
  }
  pthread_mutexattr_t ; 
  typedef union {
    struct {
      int __lock ; 
      unsigned int __futex ; 
      __extension__ unsigned long long int __total_seq ; 
      __extension__ unsigned long long int __wakeup_seq ; 
      __extension__ unsigned long long int __woken_seq ; 
      void * __mutex ; 
      unsigned int __nwaiters ; 
      unsigned int __broadcast_seq ; 
    }
    __data ; 
    char __size [48 ] ; 
    __extension__ long long int __align ; 
  }
  pthread_cond_t ; 
  typedef union {
    char __size [4 ] ; 
    long int __align ; 
  }
  pthread_condattr_t ; 
  typedef union {
    struct {
      int __lock ; 
      unsigned int __nr_readers ; 
      unsigned int __readers_wakeup ; 
      unsigned int __writer_wakeup ; 
      unsigned int __nr_readers_queued ; 
      unsigned int __nr_writers_queued ; 
      unsigned char __flags ; 
      unsigned char __shared ; 
      unsigned char __pad1 ; 
      unsigned char __pad2 ; 
      int __writer ; 
    }
    __data ; 
    char __size [32 ] ; 
    long int __align ; 
  }
  pthread_rwlock_t ; 
  typedef union {
    char __size [8 ] ; 
    long int __align ; 
  }
  pthread_rwlockattr_t ; 
  typedef union {
    char __size [20 ] ; 
    long int __align ; 
  }
  pthread_barrier_t ; 
  typedef union {
    char __size [4 ] ; 
    int __align ; 
  }
  pthread_barrierattr_t ; 
}
typedef unsigned long XID ; 
typedef unsigned long Atom ; 
typedef unsigned long VisualID ; 
typedef unsigned long Time ; 
typedef XID Window ; 
typedef XID Drawable ; 
typedef XID Font ; 
typedef XID Pixmap ; 
typedef XID Cursor ; 
typedef XID Colormap ; 
typedef XID GContext ; 
typedef XID KeySym ; 
typedef unsigned char KeyCode ; 
typedef char * XPointer ; 
typedef struct _XExtData {
  int number ; 
  struct _XExtData * next ; 
  int (* free_private ) (struct _XExtData * extension ) ; 
  XPointer private_data ; 
}
XExtData ; 
typedef struct {
  int extension ; 
  int major_opcode ; 
  int first_event ; 
  int first_error ; 
}
XExtCodes ; 
typedef struct {
  int depth ; 
  int bits_per_pixel ; 
  int scanline_pad ; 
}
XPixmapFormatValues ; 
typedef struct {
  int function ; 
  unsigned long plane_mask ; 
  unsigned long foreground ; 
  unsigned long background ; 
  int line_width ; 
  int line_style ; 
  int cap_style ; 
  int join_style ; 
  int fill_style ; 
  int fill_rule ; 
  int arc_mode ; 
  Pixmap tile ; 
  Pixmap stipple ; 
  int ts_x_origin ; 
  int ts_y_origin ; 
  Font font ; 
  int subwindow_mode ; 
  int graphics_exposures ; 
  int clip_x_origin ; 
  int clip_y_origin ; 
  Pixmap clip_mask ; 
  int dash_offset ; 
  char dashes ; 
}
XGCValues ; 
typedef struct _XGC * GC ; 
typedef struct {
  XExtData * ext_data ; 
  VisualID visualid ; 
  int c_class ; 
  unsigned long red_mask , green_mask , blue_mask ; 
  int bits_per_rgb ; 
  int map_entries ; 
}
Visual ; 
typedef struct {
  int depth ; 
  int nvisuals ; 
  Visual * visuals ; 
}
Depth ; 
struct _XDisplay ; 
typedef struct {
  XExtData * ext_data ; 
  struct _XDisplay * display ; 
  Window root ; 
  int width , height ; 
  int mwidth , mheight ; 
  int ndepths ; 
  Depth * depths ; 
  int root_depth ; 
  Visual * root_visual ; 
  GC default_gc ; 
  Colormap cmap ; 
  unsigned long white_pixel ; 
  unsigned long black_pixel ; 
  int max_maps , min_maps ; 
  int backing_store ; 
  int save_unders ; 
  long root_input_mask ; 
}
Screen ; 
typedef struct {
  XExtData * ext_data ; 
  int depth ; 
  int bits_per_pixel ; 
  int scanline_pad ; 
}
ScreenFormat ; 
typedef struct {
  Pixmap background_pixmap ; 
  unsigned long background_pixel ; 
  Pixmap border_pixmap ; 
  unsigned long border_pixel ; 
  int bit_gravity ; 
  int win_gravity ; 
  int backing_store ; 
  unsigned long backing_planes ; 
  unsigned long backing_pixel ; 
  int save_under ; 
  long event_mask ; 
  long do_not_propagate_mask ; 
  int override_redirect ; 
  Colormap colormap ; 
  Cursor cursor ; 
}
XSetWindowAttributes ; 
typedef struct {
  int x , y ; 
  int width , height ; 
  int border_width ; 
  int depth ; 
  Visual * visual ; 
  Window root ; 
  int c_class ; 
  int bit_gravity ; 
  int win_gravity ; 
  int backing_store ; 
  unsigned long backing_planes ; 
  unsigned long backing_pixel ; 
  int save_under ; 
  Colormap colormap ; 
  int map_installed ; 
  int map_state ; 
  long all_event_masks ; 
  long your_event_mask ; 
  long do_not_propagate_mask ; 
  int override_redirect ; 
  Screen * screen ; 
}
XWindowAttributes ; 
typedef struct {
  int family ; 
  int length ; 
  char * address ; 
}
XHostAddress ; 
typedef struct {
  int typelength ; 
  int valuelength ; 
  char * type ; 
  char * value ; 
}
XServerInterpretedAddress ; 
typedef struct _XImage {
  int width , height ; 
  int xoffset ; 
  int format ; 
  char * data ; 
  int byte_order ; 
  int bitmap_unit ; 
  int bitmap_bit_order ; 
  int bitmap_pad ; 
  int depth ; 
  int bytes_per_line ; 
  int bits_per_pixel ; 
  unsigned long red_mask ; 
  unsigned long green_mask ; 
  unsigned long blue_mask ; 
  XPointer obdata ; 
  struct funcs {
    struct _XImage * (* create_image ) (struct _XDisplay * , Visual * , unsigned int , int , int , char * , unsigned int , unsigned int , int , int ) ; 
    int (* destroy_image ) (struct _XImage * ) ; 
    unsigned long (* get_pixel ) (struct _XImage * , int , int ) ; 
    int (* put_pixel ) (struct _XImage * , int , int , unsigned long ) ; 
    struct _XImage * (* sub_image ) (struct _XImage * , int , int , unsigned int , unsigned int ) ; 
    int (* add_pixel ) (struct _XImage * , long ) ; 
  }
  f ; 
}
XImage ; 
typedef struct {
  int x , y ; 
  int width , height ; 
  int border_width ; 
  Window sibling ; 
  int stack_mode ; 
}
XWindowChanges ; 
typedef struct {
  unsigned long pixel ; 
  unsigned short red , green , blue ; 
  char flags ; 
  char pad ; 
}
XColor ; 
typedef struct {
  short x1 , y1 , x2 , y2 ; 
}
XSegment ; 
typedef struct {
  short x , y ; 
}
XPoint ; 
typedef struct {
  short x , y ; 
  unsigned short width , height ; 
}
XRectangle ; 
typedef struct {
  short x , y ; 
  unsigned short width , height ; 
  short angle1 , angle2 ; 
}
XArc ; 
typedef struct {
  int key_click_percent ; 
  int bell_percent ; 
  int bell_pitch ; 
  int bell_duration ; 
  int led ; 
  int led_mode ; 
  int key ; 
  int auto_repeat_mode ; 
}
XKeyboardControl ; 
typedef struct {
  int key_click_percent ; 
  int bell_percent ; 
  unsigned int bell_pitch , bell_duration ; 
  unsigned long led_mask ; 
  int global_auto_repeat ; 
  char auto_repeats [32 ] ; 
}
XKeyboardState ; 
typedef struct {
  Time time ; 
  short x , y ; 
}
XTimeCoord ; 
typedef struct {
  int max_keypermod ; 
  KeyCode * modifiermap ; 
}
XModifierKeymap ; 
typedef struct _XDisplay Display ; 
struct _XPrivate ; 
struct _XrmHashBucketRec ; 
typedef struct {
  XExtData * ext_data ; 
  struct _XPrivate * private1 ; 
  int fd ; 
  int private2 ; 
  int proto_major_version ; 
  int proto_minor_version ; 
  char * vendor ; 
  XID private3 ; 
  XID private4 ; 
  XID private5 ; 
  int private6 ; 
  XID (* resource_alloc ) (struct _XDisplay * ) ; 
  int byte_order ; 
  int bitmap_unit ; 
  int bitmap_pad ; 
  int bitmap_bit_order ; 
  int nformats ; 
  ScreenFormat * pixmap_format ; 
  int private8 ; 
  int release ; 
  struct _XPrivate * private9 , * private10 ; 
  int qlen ; 
  unsigned long last_request_read ; 
  unsigned long request ; 
  XPointer private11 ; 
  XPointer private12 ; 
  XPointer private13 ; 
  XPointer private14 ; 
  unsigned max_request_size ; 
  struct _XrmHashBucketRec * db ; 
  int (* private15 ) (struct _XDisplay * ) ; 
  char * display_name ; 
  int default_screen ; 
  int nscreens ; 
  Screen * screens ; 
  unsigned long motion_buffer ; 
  unsigned long private16 ; 
  int min_keycode ; 
  int max_keycode ; 
  XPointer private17 ; 
  XPointer private18 ; 
  int private19 ; 
  char * xdefaults ; 
}
* _XPrivDisplay ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Window root ; 
  Window subwindow ; 
  Time time ; 
  int x , y ; 
  int x_root , y_root ; 
  unsigned int state ; 
  unsigned int keycode ; 
  int same_screen ; 
}
XKeyEvent ; 
typedef XKeyEvent XKeyPressedEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Window root ; 
  Window subwindow ; 
  Time time ; 
  int x , y ; 
  int x_root , y_root ; 
  unsigned int state ; 
  unsigned int button ; 
  int same_screen ; 
}
XButtonEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Window root ; 
  Window subwindow ; 
  Time time ; 
  int x , y ; 
  int x_root , y_root ; 
  unsigned int state ; 
  char is_hint ; 
  int same_screen ; 
}
XMotionEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Window root ; 
  Window subwindow ; 
  Time time ; 
  int x , y ; 
  int x_root , y_root ; 
  int mode ; 
  int detail ; 
  int same_screen ; 
  int focus ; 
  unsigned int state ; 
}
XCrossingEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  int mode ; 
  int detail ; 
}
XFocusChangeEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  char key_vector [32 ] ; 
}
XKeymapEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  int x , y ; 
  int width , height ; 
  int count ; 
}
XExposeEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Drawable drawable ; 
  int x , y ; 
  int width , height ; 
  int count ; 
  int major_code ; 
  int minor_code ; 
}
XGraphicsExposeEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Drawable drawable ; 
  int major_code ; 
  int minor_code ; 
}
XNoExposeEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  int state ; 
}
XVisibilityEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window parent ; 
  Window window ; 
  int x , y ; 
  int width , height ; 
  int border_width ; 
  int override_redirect ; 
}
XCreateWindowEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window event ; 
  Window window ; 
}
XDestroyWindowEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window event ; 
  Window window ; 
  int from_configure ; 
}
XUnmapEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window event ; 
  Window window ; 
  int override_redirect ; 
}
XMapEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window parent ; 
  Window window ; 
}
XMapRequestEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window event ; 
  Window window ; 
  Window parent ; 
  int x , y ; 
  int override_redirect ; 
}
XReparentEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window event ; 
  Window window ; 
  int x , y ; 
  int width , height ; 
  int border_width ; 
  Window above ; 
  int override_redirect ; 
}
XConfigureEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window event ; 
  Window window ; 
  int x , y ; 
}
XGravityEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  int width , height ; 
}
XResizeRequestEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window parent ; 
  Window window ; 
  int x , y ; 
  int width , height ; 
  int border_width ; 
  Window above ; 
  int detail ; 
  unsigned long value_mask ; 
}
XConfigureRequestEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window event ; 
  Window window ; 
  int place ; 
}
XCirculateEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window parent ; 
  Window window ; 
  int place ; 
}
XCirculateRequestEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Atom atom ; 
  Time time ; 
  int state ; 
}
XPropertyEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Atom selection ; 
  Time time ; 
}
XSelectionClearEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window owner ; 
  Window requestor ; 
  Atom selection ; 
  Atom target ; 
  Atom property ; 
  Time time ; 
}
XSelectionRequestEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window requestor ; 
  Atom selection ; 
  Atom target ; 
  Atom property ; 
  Time time ; 
}
XSelectionEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Colormap colormap ; 
  int c_new ; 
  int state ; 
}
XColormapEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  Atom message_type ; 
  int format ; 
  union {
    char b [20 ] ; 
    short s [10 ] ; 
    long l [5 ] ; 
  }
  data ; 
}
XClientMessageEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
  int request ; 
  int first_keycode ; 
  int count ; 
}
XMappingEvent ; 
typedef struct {
  int type ; 
  Display * display ; 
  XID resourceid ; 
  unsigned long serial ; 
  unsigned char error_code ; 
  unsigned char request_code ; 
  unsigned char minor_code ; 
}
XErrorEvent ; 
typedef struct {
  int type ; 
  unsigned long serial ; 
  int send_event ; 
  Display * display ; 
  Window window ; 
}
XAnyEvent ; 
typedef union _XEvent {
  int type ; 
  XAnyEvent xany ; 
  XKeyEvent xkey ; 
  XButtonEvent xbutton ; 
  XMotionEvent xmotion ; 
  XCrossingEvent xcrossing ; 
  XFocusChangeEvent xfocus ; 
  XExposeEvent xexpose ; 
  XGraphicsExposeEvent xgraphicsexpose ; 
  XNoExposeEvent xnoexpose ; 
  XVisibilityEvent xvisibility ; 
  XCreateWindowEvent xcreatewindow ; 
  XDestroyWindowEvent xdestroywindow ; 
  XUnmapEvent xunmap ; 
  XMapEvent xmap ; 
  XMapRequestEvent xmaprequest ; 
  XReparentEvent xreparent ; 
  XConfigureEvent xconfigure ; 
  XGravityEvent xgravity ; 
  XResizeRequestEvent xresizerequest ; 
  XConfigureRequestEvent xconfigurerequest ; 
  XCirculateEvent xcirculate ; 
  XCirculateRequestEvent xcirculaterequest ; 
  XPropertyEvent xproperty ; 
  XSelectionClearEvent xselectionclear ; 
  XSelectionRequestEvent xselectionrequest ; 
  XSelectionEvent xselection ; 
  XColormapEvent xcolormap ; 
  XClientMessageEvent xclient ; 
  XMappingEvent xmapping ; 
  XErrorEvent xerror ; 
  XKeymapEvent xkeymap ; 
  long pad [24 ] ; 
}
XEvent ; 
typedef struct {
  short lbearing ; 
  short rbearing ; 
  short width ; 
  short ascent ; 
  short descent ; 
  unsigned short attributes ; 
}
XCharStruct ; 
typedef struct {
  Atom name ; 
  unsigned long card32 ; 
}
XFontProp ; 
typedef struct {
  XExtData * ext_data ; 
  Font fid ; 
  unsigned direction ; 
  unsigned min_char_or_byte2 ; 
  unsigned max_char_or_byte2 ; 
  unsigned min_byte1 ; 
  unsigned max_byte1 ; 
  int all_chars_exist ; 
  unsigned default_char ; 
  int n_properties ; 
  XFontProp * properties ; 
  XCharStruct min_bounds ; 
  XCharStruct max_bounds ; 
  XCharStruct * per_char ; 
  int ascent ; 
  int descent ; 
}
XFontStruct ; 
typedef struct {
  char * chars ; 
  int nchars ; 
  int delta ; 
  Font font ; 
}
XTextItem ; 
typedef struct {
  unsigned char byte1 ; 
  unsigned char byte2 ; 
}
XChar2b ; 
typedef struct {
  XChar2b * chars ; 
  int nchars ; 
  int delta ; 
  Font font ; 
}
XTextItem16 ; 
typedef union {
  Display * display ; 
  GC gc ; 
  Visual * visual ; 
  Screen * screen ; 
  ScreenFormat * pixmap_format ; 
  XFontStruct * font ; 
}
XEDataObject ; 
typedef struct {
  XRectangle max_ink_extent ; 
  XRectangle max_logical_extent ; 
}
XFontSetExtents ; 
typedef struct _XOM * XOM ; 
typedef struct _XOC * XOC , * XFontSet ; 
typedef struct {
  char * chars ; 
  int nchars ; 
  int delta ; 
  XFontSet font_set ; 
}
XmbTextItem ; 
typedef struct {
  wchar_t * chars ; 
  int nchars ; 
  int delta ; 
  XFontSet font_set ; 
}
XwcTextItem ; 
typedef struct {
  int charset_count ; 
  char * * charset_list ; 
}
XOMCharSetList ; 
typedef enum {
  XOMOrientation_LTR_TTB , XOMOrientation_RTL_TTB , XOMOrientation_TTB_LTR , XOMOrientation_TTB_RTL , XOMOrientation_Context }
XOrientation ; 
typedef struct {
  int num_orientation ; 
  XOrientation * orientation ; 
}
XOMOrientation ; 
typedef struct {
  int num_font ; 
  XFontStruct * * font_struct_list ; 
  char * * font_name_list ; 
}
XOMFontInfo ; 
typedef struct _XIM * XIM ; 
typedef struct _XIC * XIC ; 
typedef void (* XIMProc ) (XIM , XPointer , XPointer ) ; 
typedef int (* XICProc ) (XIC , XPointer , XPointer ) ; 
typedef void (* XIDProc ) (Display * , XPointer , XPointer ) ; 
typedef unsigned long XIMStyle ; 
typedef struct {
  unsigned short count_styles ; 
  XIMStyle * supported_styles ; 
}
XIMStyles ; 
typedef void * XVaNestedList ; 
typedef struct {
  XPointer client_data ; 
  XIMProc callback ; 
}
XIMCallback ; 
typedef struct {
  XPointer client_data ; 
  XICProc callback ; 
}
XICCallback ; 
typedef unsigned long XIMFeedback ; 
typedef struct _XIMText {
  unsigned short length ; 
  XIMFeedback * feedback ; 
  int encoding_is_wchar ; 
  union {
    char * multi_byte ; 
    wchar_t * wide_char ; 
  }
  string ; 
}
XIMText ; 
typedef unsigned long XIMPreeditState ; 
typedef struct _XIMPreeditStateNotifyCallbackStruct {
  XIMPreeditState state ; 
}
XIMPreeditStateNotifyCallbackStruct ; 
typedef unsigned long XIMStringConversionFeedback ; 
typedef struct _XIMStringConversionText {
  unsigned short length ; 
  XIMStringConversionFeedback * feedback ; 
  int encoding_is_wchar ; 
  union {
    char * mbs ; 
    wchar_t * wcs ; 
  }
  string ; 
}
XIMStringConversionText ; 
typedef unsigned short XIMStringConversionPosition ; 
typedef unsigned short XIMStringConversionOperation ; 
typedef enum {
  XIMForwardChar , XIMBackwardChar , XIMForwardWord , XIMBackwardWord , XIMCaretUp , XIMCaretDown , XIMNextLine , XIMPreviousLine , XIMLineStart , XIMLineEnd , XIMAbsolutePosition , XIMDontChange }
XIMCaretDirection ; 
typedef struct _XIMStringConversionCallbackStruct {
  XIMStringConversionPosition position ; 
  XIMCaretDirection direction ; 
  XIMStringConversionOperation operation ; 
  unsigned short factor ; 
  XIMStringConversionText * text ; 
}
XIMStringConversionCallbackStruct ; 
typedef struct _XIMPreeditDrawCallbackStruct {
  int caret ; 
  int chg_first ; 
  int chg_length ; 
  XIMText * text ; 
}
XIMPreeditDrawCallbackStruct ; 
typedef enum {
  XIMIsInvisible , XIMIsPrimary , XIMIsSecondary }
XIMCaretStyle ; 
typedef struct _XIMPreeditCaretCallbackStruct {
  int position ; 
  XIMCaretDirection direction ; 
  XIMCaretStyle style ; 
}
XIMPreeditCaretCallbackStruct ; 
typedef enum {
  XIMTextType , XIMBitmapType }
XIMStatusDataType ; 
typedef struct _XIMStatusDrawCallbackStruct {
  XIMStatusDataType type ; 
  union {
    XIMText * text ; 
    Pixmap bitmap ; 
  }
  data ; 
}
XIMStatusDrawCallbackStruct ; 
typedef struct _XIMHotKeyTrigger {
  KeySym keysym ; 
  int modifier ; 
  int modifier_mask ; 
}
XIMHotKeyTrigger ; 
typedef struct _XIMHotKeyTriggers {
  int num_hot_key ; 
  XIMHotKeyTrigger * key ; 
}
XIMHotKeyTriggers ; 
typedef struct {
  unsigned short count_values ; 
  char * * supported_values ; 
}
XIMValuesList ; 
extern "C" {
  extern int (* XSynchronize (Display * , int ) ) (Display * ) ; 
  extern int (* XSetAfterFunction (Display * , int (* ) (Display * ) ) ) (Display * ) ; 
  typedef int (* XErrorHandler ) (Display * , XErrorEvent * ) ; 
  typedef int (* XIOErrorHandler ) (Display * ) ; 
  typedef void (* XConnectionWatchProc ) (Display * , XPointer , int , int , XPointer * ) ; 
}
typedef struct {
  long flags ; 
  int x , y ; 
  int width , height ; 
  int min_width , min_height ; 
  int max_width , max_height ; 
  int width_inc , height_inc ; 
  struct {
    int x ; 
    int y ; 
  }
  min_aspect , max_aspect ; 
  int base_width , base_height ; 
  int win_gravity ; 
}
XSizeHints ; 
typedef struct {
  long flags ; 
  int input ; 
  int initial_state ; 
  Pixmap icon_pixmap ; 
  Window icon_window ; 
  int icon_x , icon_y ; 
  Pixmap icon_mask ; 
  XID window_group ; 
}
XWMHints ; 
typedef struct {
  unsigned char * value ; 
  Atom encoding ; 
  int format ; 
  unsigned long nitems ; 
}
XTextProperty ; 
typedef enum {
  XStringStyle , XCompoundTextStyle , XTextStyle , XStdICCTextStyle , XUTF8StringStyle }
XICCEncodingStyle ; 
typedef struct {
  int min_width , min_height ; 
  int max_width , max_height ; 
  int width_inc , height_inc ; 
}
XIconSize ; 
typedef struct {
  char * res_name ; 
  char * res_class ; 
}
XClassHint ; 
typedef struct _XComposeStatus {
  XPointer compose_ptr ; 
  int chars_matched ; 
}
XComposeStatus ; 
typedef struct _XRegion * Region ; 
typedef struct {
  Visual * visual ; 
  VisualID visualid ; 
  int screen ; 
  int depth ; 
  int c_class ; 
  unsigned long red_mask ; 
  unsigned long green_mask ; 
  unsigned long blue_mask ; 
  int colormap_size ; 
  int bits_per_rgb ; 
}
XVisualInfo ; 
typedef struct {
  Colormap colormap ; 
  unsigned long red_max ; 
  unsigned long red_mult ; 
  unsigned long green_max ; 
  unsigned long green_mult ; 
  unsigned long blue_max ; 
  unsigned long blue_mult ; 
  unsigned long base_pixel ; 
  VisualID visualid ; 
  XID killid ; 
}
XStandardColormap ; 
typedef int XContext ; 
extern "C" {
}
extern "C" {
  typedef int XrmQuark , * XrmQuarkList ; 
  typedef char * XrmString ; 
  typedef enum {
    XrmBindTightly , XrmBindLoosely }
  XrmBinding , * XrmBindingList ; 
  typedef XrmQuark XrmName ; 
  typedef XrmQuarkList XrmNameList ; 
  typedef XrmQuark XrmClass ; 
  typedef XrmQuarkList XrmClassList ; 
  typedef XrmQuark XrmRepresentation ; 
  typedef struct {
    unsigned int size ; 
    XPointer addr ; 
  }
  XrmValue , * XrmValuePtr ; 
  typedef struct _XrmHashBucketRec * XrmHashBucket ; 
  typedef XrmHashBucket * XrmHashTable ; 
  typedef XrmHashTable XrmSearchList [] ; 
  typedef struct _XrmHashBucketRec * XrmDatabase ; 
  typedef enum {
    XrmoptionNoArg , XrmoptionIsArg , XrmoptionStickyArg , XrmoptionSepArg , XrmoptionResArg , XrmoptionSkipArg , XrmoptionSkipLine , XrmoptionSkipNArgs }
  XrmOptionKind ; 
  typedef struct {
    char * option ; 
    char * specifier ; 
    XrmOptionKind argKind ; 
    XPointer value ; 
  }
  XrmOptionDescRec , * XrmOptionDescList ; 
}
extern "C" {
  extern void * memcpy (void * __restrict __dest , __const void * __restrict __src , size_t __n ) throw () __attribute__ ((__nonnull__ (1 , 2 ) ) ) ; 
  extern void * memset (void * __s , int __c , size_t __n ) throw () __attribute__ ((__nonnull__ (1 ) ) ) ; 
  extern int strcmp (__const char * __s1 , __const char * __s2 ) throw () __attribute__ ((__pure__ ) ) __attribute__ ((__nonnull__ (1 , 2 ) ) ) ; 
  typedef struct __locale_struct {
    struct locale_data * __locales [13 ] ; 
    const unsigned short int * __ctype_b ; 
    const int * __ctype_tolower ; 
    const int * __ctype_toupper ; 
    const char * __names [13 ] ; 
  }
  * __locale_t ; 
  extern size_t strlen (__const char * __s ) throw () __attribute__ ((__pure__ ) ) __attribute__ ((__nonnull__ (1 ) ) ) ; 
}
typedef char * String ; 
typedef struct _WidgetRec * Widget ; 
typedef Widget * WidgetList ; 
typedef struct _WidgetClassRec * WidgetClass ; 
typedef struct _XtActionsRec * XtActionList ; 
typedef struct _XtEventRec * XtEventTable ; 
typedef struct _XtAppStruct * XtAppContext ; 
typedef unsigned long XtValueMask ; 
typedef unsigned long XtIntervalId ; 
typedef unsigned long XtInputId ; 
typedef unsigned long XtWorkProcId ; 
typedef unsigned long XtSignalId ; 
typedef unsigned int XtGeometryMask ; 
typedef unsigned long XtGCMask ; 
typedef unsigned long Pixel ; 
typedef int XtCacheType ; 
typedef char Boolean ; 
typedef long XtArgVal ; 
typedef unsigned char XtEnum ; 
typedef unsigned int Cardinal ; 
typedef unsigned short Dimension ; 
typedef short Position ; 
typedef void * XtPointer ; 
typedef XtPointer Opaque ; 
typedef Cardinal (* XtOrderProc ) (Widget ) ; 
extern "C" {
  typedef void (* XtDoChangeProc ) (Widget , WidgetList , Cardinal * , WidgetList , Cardinal * , XtPointer ) ; 
}
typedef struct _TranslationData * XtTranslations ; 
typedef struct _TranslationData * XtAccelerators ; 
typedef unsigned int Modifiers ; 
typedef void (* XtActionProc ) (Widget , XEvent * , String * , Cardinal * ) ; 
typedef XtActionProc * XtBoundActions ; 
typedef struct _XtActionsRec {
  String string ; 
  XtActionProc proc ; 
}
XtActionsRec ; 
typedef enum {
  XtAddress , XtBaseOffset , XtImmediate , XtResourceString , XtResourceQuark , XtWidgetBaseOffset , XtProcedureArg }
XtAddressMode ; 
typedef struct {
  XtAddressMode address_mode ; 
  XtPointer address_id ; 
  Cardinal size ; 
}
XtConvertArgRec , * XtConvertArgList ; 
typedef void (* XtConvertArgProc ) (Widget , Cardinal * , XrmValue * ) ; 
typedef struct {
  XtGeometryMask request_mode ; 
  Position x , y ; 
  Dimension width , height , border_width ; 
  Widget sibling ; 
  int stack_mode ; 
}
XtWidgetGeometry ; 
typedef void (* XtConverter ) (XrmValue * , Cardinal * , XrmValue * , XrmValue * ) ; 
typedef Boolean (* XtTypeConverter ) (Display * , XrmValue * , Cardinal * , XrmValue * , XrmValue * , XtPointer * ) ; 
typedef void (* XtDestructor ) (XtAppContext , XrmValue * , XtPointer , XrmValue * , Cardinal * ) ; 
typedef Opaque XtCacheRef ; 
typedef Opaque XtActionHookId ; 
typedef void (* XtActionHookProc ) (Widget , XtPointer , String , XEvent * , String * , Cardinal * ) ; 
typedef unsigned long XtBlockHookId ; 
typedef void (* XtBlockHookProc ) (XtPointer ) ; 
typedef void (* XtKeyProc ) (Display * , KeyCode , Modifiers , Modifiers * , KeySym * ) ; 
typedef void (* XtCaseProc ) (Display * , KeySym , KeySym * , KeySym * ) ; 
typedef void (* XtEventHandler ) (Widget , XtPointer , XEvent * , Boolean * ) ; 
typedef unsigned long EventMask ; 
typedef enum {
  XtListHead , XtListTail }
XtListPosition ; 
typedef unsigned long XtInputMask ; 
typedef void (* XtTimerCallbackProc ) (XtPointer , XtIntervalId * ) ; 
typedef void (* XtInputCallbackProc ) (XtPointer , int * , XtInputId * ) ; 
typedef void (* XtSignalCallbackProc ) (XtPointer , XtSignalId * ) ; 
typedef struct {
  String name ; 
  XtArgVal value ; 
}
Arg , * ArgList ; 
typedef XtPointer XtVarArgsList ; 
typedef void (* XtCallbackProc ) (Widget , XtPointer , XtPointer ) ; 
typedef struct _XtCallbackRec {
  XtCallbackProc callback ; 
  XtPointer closure ; 
}
XtCallbackRec , * XtCallbackList ; 
typedef enum {
  XtCallbackNoList , XtCallbackHasNone , XtCallbackHasSome }
XtCallbackStatus ; 
typedef enum {
  XtGeometryYes , XtGeometryNo , XtGeometryAlmost , XtGeometryDone }
XtGeometryResult ; 
typedef enum {
  XtGrabNone , XtGrabNonexclusive , XtGrabExclusive }
XtGrabKind ; 
typedef struct {
  Widget shell_widget ; 
  Widget enable_widget ; 
}
XtPopdownIDRec , * XtPopdownID ; 
typedef struct _XtResource {
  String resource_name ; 
  String resource_class ; 
  String resource_type ; 
  Cardinal resource_size ; 
  Cardinal resource_offset ; 
  String default_type ; 
  XtPointer default_addr ; 
}
XtResource , * XtResourceList ; 
typedef void (* XtResourceDefaultProc ) (Widget , int , XrmValue * ) ; 
typedef String (* XtLanguageProc ) (Display * , String , XtPointer ) ; 
typedef void (* XtErrorMsgHandler ) (String , String , String , String , String * , Cardinal * ) ; 
typedef void (* XtErrorHandler ) (String ) ; 
typedef void (* XtCreatePopupChildProc ) (Widget ) ; 
typedef Boolean (* XtWorkProc ) (XtPointer ) ; 
typedef struct {
  char match ; 
  String substitution ; 
}
SubstitutionRec , * Substitution ; 
typedef Boolean (* XtFilePredicate ) (String ) ; 
typedef XtPointer XtRequestId ; 
typedef Boolean (* XtConvertSelectionProc ) (Widget , Atom * , Atom * , Atom * , XtPointer * , unsigned long * , int * ) ; 
typedef void (* XtLoseSelectionProc ) (Widget , Atom * ) ; 
typedef void (* XtSelectionDoneProc ) (Widget , Atom * , Atom * ) ; 
typedef void (* XtSelectionCallbackProc ) (Widget , XtPointer , Atom * , Atom * , XtPointer , unsigned long * , int * ) ; 
typedef void (* XtLoseSelectionIncrProc ) (Widget , Atom * , XtPointer ) ; 
typedef void (* XtSelectionDoneIncrProc ) (Widget , Atom * , Atom * , XtRequestId * , XtPointer ) ; 
typedef Boolean (* XtConvertSelectionIncrProc ) (Widget , Atom * , Atom * , Atom * , XtPointer * , unsigned long * , int * , unsigned long * , XtPointer , XtRequestId * ) ; 
typedef void (* XtCancelConvertSelectionProc ) (Widget , Atom * , Atom * , XtRequestId * , XtPointer ) ; 
typedef Boolean (* XtEventDispatchProc ) (XEvent * ) ; 
typedef void (* XtExtensionSelectProc ) (Widget , int * , XtPointer * , int , XtPointer ) ; 
extern "C" {
  extern XtConvertArgRec const colorConvertArgs [] ; 
  extern XtConvertArgRec const screenConvertArg [] ; 
  typedef struct _XtCheckpointTokenRec {
    int save_type ; 
    int interact_style ; 
    Boolean shutdown ; 
    Boolean fast ; 
    Boolean cancel_shutdown ; 
    int phase ; 
    int interact_dialog_type ; 
    Boolean request_cancel ; 
    Boolean request_next_phase ; 
    Boolean save_success ; 
    int type ; 
    Widget widget ; 
  }
  XtCheckpointTokenRec , * XtCheckpointToken ; 
  typedef struct {
    String type ; 
    Widget widget ; 
    ArgList args ; 
    Cardinal num_args ; 
  }
  XtCreateHookDataRec , * XtCreateHookData ; 
  typedef struct {
    String type ; 
    Widget widget ; 
    XtPointer event_data ; 
    Cardinal num_event_data ; 
  }
  XtChangeHookDataRec , * XtChangeHookData ; 
  typedef struct {
    Widget old , req ; 
    ArgList args ; 
    Cardinal num_args ; 
  }
  XtChangeHookSetValuesDataRec , * XtChangeHookSetValuesData ; 
  typedef struct {
    String type ; 
    Widget widget ; 
    XtGeometryMask changeMask ; 
    XWindowChanges changes ; 
  }
  XtConfigureHookDataRec , * XtConfigureHookData ; 
  typedef struct {
    String type ; 
    Widget widget ; 
    XtWidgetGeometry * request ; 
    XtWidgetGeometry * reply ; 
    XtGeometryResult result ; 
  }
  XtGeometryHookDataRec , * XtGeometryHookData ; 
  typedef struct {
    String type ; 
    Widget widget ; 
  }
  XtDestroyHookDataRec , * XtDestroyHookData ; 
}
typedef struct {
  long xrm_name ; 
  long xrm_class ; 
  long xrm_type ; 
  Cardinal xrm_size ; 
  int xrm_offset ; 
  long xrm_default_type ; 
  XtPointer xrm_default_addr ; 
}
XrmResource , * XrmResourceList ; 
typedef unsigned long XtVersionType ; 
typedef void (* XtProc ) (void ) ; 
typedef void (* XtWidgetClassProc ) (WidgetClass ) ; 
typedef void (* XtWidgetProc ) (Widget ) ; 
typedef Boolean (* XtAcceptFocusProc ) (Widget , Time * ) ; 
typedef void (* XtArgsProc ) (Widget , ArgList , Cardinal * ) ; 
typedef void (* XtInitProc ) (Widget , Widget , ArgList , Cardinal * ) ; 
typedef Boolean (* XtSetValuesFunc ) (Widget , Widget , Widget , ArgList , Cardinal * ) ; 
typedef Boolean (* XtArgsFunc ) (Widget , ArgList , Cardinal * ) ; 
typedef void (* XtAlmostProc ) (Widget , Widget , XtWidgetGeometry * , XtWidgetGeometry * ) ; 
typedef void (* XtExposeProc ) (Widget , XEvent * , Region ) ; 
typedef void (* XtRealizeProc ) (Widget , XtValueMask * , XSetWindowAttributes * ) ; 
typedef XtGeometryResult (* XtGeometryHandler ) (Widget , XtWidgetGeometry * , XtWidgetGeometry * ) ; 
typedef void (* XtStringProc ) (Widget , String ) ; 
typedef struct {
  String name ; 
  String type ; 
  XtArgVal value ; 
  int size ; 
}
XtTypedArg , * XtTypedArgList ; 
typedef void (* XtAllocateProc ) (WidgetClass , Cardinal * , Cardinal * , ArgList , Cardinal * , XtTypedArgList , Cardinal * , Widget * , XtPointer * ) ; 
typedef void (* XtDeallocateProc ) (Widget , XtPointer ) ; 
struct _XtStateRec ; 
typedef struct _XtTMRec {
  XtTranslations translations ; 
  XtBoundActions proc_table ; 
  struct _XtStateRec * current_state ; 
  unsigned long lastEventTime ; 
}
XtTMRec , * XtTM ; 
typedef struct _CorePart {
  Widget self ; 
  WidgetClass widget_class ; 
  Widget parent ; 
  XrmName xrm_name ; 
  Boolean being_destroyed ; 
  XtCallbackList destroy_callbacks ; 
  XtPointer constraints ; 
  Position x , y ; 
  Dimension width , height ; 
  Dimension border_width ; 
  Boolean managed ; 
  Boolean sensitive ; 
  Boolean ancestor_sensitive ; 
  XtEventTable event_table ; 
  XtTMRec tm ; 
  XtTranslations accelerators ; 
  Pixel border_pixel ; 
  Pixmap border_pixmap ; 
  WidgetList popup_list ; 
  Cardinal num_popups ; 
  String name ; 
  Screen * screen ; 
  Colormap colormap ; 
  Window window ; 
  Cardinal depth ; 
  Pixel background_pixel ; 
  Pixmap background_pixmap ; 
  Boolean visible ; 
  Boolean mapped_when_managed ; 
}
CorePart ; 
typedef struct _WidgetRec {
  CorePart core ; 
}
WidgetRec , CoreRec ; 
typedef struct _CoreClassPart {
  WidgetClass superclass ; 
  String class_name ; 
  Cardinal widget_size ; 
  XtProc class_initialize ; 
  XtWidgetClassProc class_part_initialize ; 
  XtEnum class_inited ; 
  XtInitProc initialize ; 
  XtArgsProc initialize_hook ; 
  XtRealizeProc realize ; 
  XtActionList actions ; 
  Cardinal num_actions ; 
  XtResourceList resources ; 
  Cardinal num_resources ; 
  XrmClass xrm_class ; 
  Boolean compress_motion ; 
  XtEnum compress_exposure ; 
  Boolean compress_enterleave ; 
  Boolean visible_interest ; 
  XtWidgetProc destroy ; 
  XtWidgetProc resize ; 
  XtExposeProc expose ; 
  XtSetValuesFunc set_values ; 
  XtArgsFunc set_values_hook ; 
  XtAlmostProc set_values_almost ; 
  XtArgsProc get_values_hook ; 
  XtAcceptFocusProc accept_focus ; 
  XtVersionType version ; 
  XtPointer callback_private ; 
  String tm_table ; 
  XtGeometryHandler query_geometry ; 
  XtStringProc display_accelerator ; 
  XtPointer extension ; 
}
CoreClassPart ; 
typedef struct _WidgetClassRec {
  CoreClassPart core_class ; 
}
WidgetClassRec , CoreClassRec ; 
typedef struct _CompositePart {
  WidgetList children ; 
  Cardinal num_children ; 
  Cardinal num_slots ; 
  XtOrderProc insert_position ; 
}
CompositePart , * CompositePtr ; 
typedef struct _CompositeRec {
  CorePart core ; 
  CompositePart composite ; 
}
CompositeRec ; 
typedef struct _CompositeClassPart {
  XtGeometryHandler geometry_manager ; 
  XtWidgetProc change_managed ; 
  XtWidgetProc insert_child ; 
  XtWidgetProc delete_child ; 
  XtPointer extension ; 
}
CompositeClassPart , * CompositePartPtr ; 
typedef struct {
  XtPointer next_extension ; 
  XrmQuark record_type ; 
  long version ; 
  Cardinal record_size ; 
  Boolean accepts_objects ; 
  Boolean allows_change_managed_set ; 
}
CompositeClassExtensionRec , * CompositeClassExtension ; 
typedef struct _CompositeClassRec {
  CoreClassPart core_class ; 
  CompositeClassPart composite_class ; 
}
CompositeClassRec ; 
typedef struct _ConstraintPart {
  XtPointer mumble ; 
}
ConstraintPart ; 
typedef struct _ConstraintRec {
  CorePart core ; 
  CompositePart composite ; 
  ConstraintPart constraint ; 
}
ConstraintRec , * ConstraintWidget ; 
typedef struct _ConstraintClassPart {
  XtResourceList resources ; 
  Cardinal num_resources ; 
  Cardinal constraint_size ; 
  XtInitProc initialize ; 
  XtWidgetProc destroy ; 
  XtSetValuesFunc set_values ; 
  XtPointer extension ; 
}
ConstraintClassPart ; 
typedef struct {
  XtPointer next_extension ; 
  XrmQuark record_type ; 
  long version ; 
  Cardinal record_size ; 
  XtArgsProc get_values_hook ; 
}
ConstraintClassExtensionRec , * ConstraintClassExtension ; 
typedef struct _ConstraintClassRec {
  CoreClassPart core_class ; 
  CompositeClassPart composite_class ; 
  ConstraintClassPart constraint_class ; 
}
ConstraintClassRec ; 
typedef struct _ObjectPart {
  Widget self ; 
  WidgetClass widget_class ; 
  Widget parent ; 
  XrmName xrm_name ; 
  Boolean being_destroyed ; 
  XtCallbackList destroy_callbacks ; 
  XtPointer constraints ; 
}
ObjectPart ; 
typedef struct _ObjectRec {
  ObjectPart object ; 
}
ObjectRec ; 
typedef struct _ObjectClassPart {
  WidgetClass superclass ; 
  String class_name ; 
  Cardinal widget_size ; 
  XtProc class_initialize ; 
  XtWidgetClassProc class_part_initialize ; 
  XtEnum class_inited ; 
  XtInitProc initialize ; 
  XtArgsProc initialize_hook ; 
  XtProc obj1 ; 
  XtPointer obj2 ; 
  Cardinal obj3 ; 
  XtResourceList resources ; 
  Cardinal num_resources ; 
  XrmClass xrm_class ; 
  Boolean obj4 ; 
  XtEnum obj5 ; 
  Boolean obj6 ; 
  Boolean obj7 ; 
  XtWidgetProc destroy ; 
  XtProc obj8 ; 
  XtProc obj9 ; 
  XtSetValuesFunc set_values ; 
  XtArgsFunc set_values_hook ; 
  XtProc obj10 ; 
  XtArgsProc get_values_hook ; 
  XtProc obj11 ; 
  XtVersionType version ; 
  XtPointer callback_private ; 
  String obj12 ; 
  XtProc obj13 ; 
  XtProc obj14 ; 
  XtPointer extension ; 
}
ObjectClassPart ; 
typedef struct {
  XtPointer next_extension ; 
  XrmQuark record_type ; 
  long version ; 
  Cardinal record_size ; 
  XtAllocateProc allocate ; 
  XtDeallocateProc deallocate ; 
}
ObjectClassExtensionRec , * ObjectClassExtension ; 
typedef struct _ObjectClassRec {
  ObjectClassPart object_class ; 
}
ObjectClassRec ; 
typedef struct _RectObjPart {
  Position x , y ; 
  Dimension width , height ; 
  Dimension border_width ; 
  Boolean managed ; 
  Boolean sensitive ; 
  Boolean ancestor_sensitive ; 
}
RectObjPart ; 
typedef struct _RectObjRec {
  ObjectPart object ; 
  RectObjPart rectangle ; 
}
RectObjRec ; 
typedef struct _RectObjClassPart {
  WidgetClass superclass ; 
  String class_name ; 
  Cardinal widget_size ; 
  XtProc class_initialize ; 
  XtWidgetClassProc class_part_initialize ; 
  XtEnum class_inited ; 
  XtInitProc initialize ; 
  XtArgsProc initialize_hook ; 
  XtProc rect1 ; 
  XtPointer rect2 ; 
  Cardinal rect3 ; 
  XtResourceList resources ; 
  Cardinal num_resources ; 
  XrmClass xrm_class ; 
  Boolean rect4 ; 
  XtEnum rect5 ; 
  Boolean rect6 ; 
  Boolean rect7 ; 
  XtWidgetProc destroy ; 
  XtWidgetProc resize ; 
  XtExposeProc expose ; 
  XtSetValuesFunc set_values ; 
  XtArgsFunc set_values_hook ; 
  XtAlmostProc set_values_almost ; 
  XtArgsProc get_values_hook ; 
  XtProc rect9 ; 
  XtVersionType version ; 
  XtPointer callback_private ; 
  String rect10 ; 
  XtGeometryHandler query_geometry ; 
  XtProc rect11 ; 
  XtPointer extension ; 
}
RectObjClassPart ; 
typedef struct _RectObjClassRec {
  RectObjClassPart rect_class ; 
}
RectObjClassRec ; 
extern "C" {
}
extern "C" {
  struct _IO_FILE ; 
  typedef struct _IO_FILE FILE ; 
  typedef struct {
    int __count ; 
    union {
      unsigned int __wch ; 
      char __wchb [4 ] ; 
    }
    __value ; 
  }
  __mbstate_t ; 
  typedef struct {
    __off_t __pos ; 
    __mbstate_t __state ; 
  }
  _G_fpos_t ; 
  typedef struct {
    __off64_t __pos ; 
    __mbstate_t __state ; 
  }
  _G_fpos64_t ; 
  typedef int _G_int16_t __attribute__ ((__mode__ (__HI__ ) ) ) ; 
  typedef int _G_int32_t __attribute__ ((__mode__ (__SI__ ) ) ) ; 
  typedef unsigned int _G_uint16_t __attribute__ ((__mode__ (__HI__ ) ) ) ; 
  typedef unsigned int _G_uint32_t __attribute__ ((__mode__ (__SI__ ) ) ) ; 
  typedef __builtin_va_list __gnuc_va_list ; 
  struct _IO_FILE ; 
  typedef void _IO_lock_t ; 
  struct _IO_marker {
    struct _IO_marker * _next ; 
    struct _IO_FILE * _sbuf ; 
    int _pos ; 
  }
  ; 
  enum __codecvt_result {
    __codecvt_ok , __codecvt_partial , __codecvt_error , __codecvt_noconv }
  ; 
  struct _IO_FILE {
    int _flags ; 
    char * _IO_read_ptr ; 
    char * _IO_read_end ; 
    char * _IO_read_base ; 
    char * _IO_write_base ; 
    char * _IO_write_ptr ; 
    char * _IO_write_end ; 
    char * _IO_buf_base ; 
    char * _IO_buf_end ; 
    char * _IO_save_base ; 
    char * _IO_backup_base ; 
    char * _IO_save_end ; 
    struct _IO_marker * _markers ; 
    struct _IO_FILE * _chain ; 
    int _fileno ; 
    int _flags2 ; 
    __off_t _old_offset ; 
    unsigned short _cur_column ; 
    signed char _vtable_offset ; 
    char _shortbuf [1 ] ; 
    _IO_lock_t * _lock ; 
    __off64_t _offset ; 
    void * __pad1 ; 
    void * __pad2 ; 
    void * __pad3 ; 
    void * __pad4 ; 
    size_t __pad5 ; 
    int _mode ; 
    char _unused2 [15 * sizeof (int ) - 4 * sizeof (void * ) - sizeof (size_t ) ] ; 
  }
  ; 
  struct _IO_FILE_plus ; 
  typedef __ssize_t __io_read_fn (void * __cookie , char * __buf , size_t __nbytes ) ; 
  typedef __ssize_t __io_write_fn (void * __cookie , __const char * __buf , size_t __n ) ; 
  typedef int __io_seek_fn (void * __cookie , __off64_t * __pos , int __w ) ; 
  typedef int __io_close_fn (void * __cookie ) ; 
  typedef struct {
    __io_read_fn * read ; 
    __io_write_fn * write ; 
    __io_seek_fn * seek ; 
    __io_close_fn * close ; 
  }
  _IO_cookie_io_functions_t ; 
  struct _IO_cookie_file ; 
  extern "C" {
  }
  typedef _G_fpos_t fpos_t ; 
  typedef _G_fpos64_t fpos64_t ; 
  extern struct _IO_FILE * stdout ; 
  extern int fflush (FILE * __stream ) ; 
  extern int printf (__const char * __restrict __format , ... ) ; 
  extern __const char * __const sys_errlist [] ; 
  extern __const char * __const _sys_errlist [] ; 
  struct obstack ; 
}
extern "C" {
  union wait {
    int w_status ; 
    struct {
      unsigned int __w_termsig : 7 ; 
      unsigned int __w_coredump : 1 ; 
      unsigned int __w_retcode : 8 ; 
      unsigned int : 16 ; 
    }
    __wait_terminated ; 
    struct {
      unsigned int __w_stopval : 8 ; 
      unsigned int __w_stopsig : 8 ; 
      unsigned int : 16 ; 
    }
    __wait_stopped ; 
  }
  ; 
  typedef struct {
    int quot ; 
    int rem ; 
  }
  div_t ; 
  typedef struct {
    long int quot ; 
    long int rem ; 
  }
  ldiv_t ; 
  __extension__ typedef struct {
    long long int quot ; 
    long long int rem ; 
  }
  lldiv_t ; 
  struct random_data {
    int32_t * fptr ; 
    int32_t * rptr ; 
    int32_t * state ; 
    int rand_type ; 
    int rand_deg ; 
    int rand_sep ; 
    int32_t * end_ptr ; 
  }
  ; 
  struct drand48_data {
    unsigned short int __x [3 ] ; 
    unsigned short int __old_x [3 ] ; 
    unsigned short int __c ; 
    unsigned short int __init ; 
    unsigned long long int __a ; 
  }
  ; 
  extern void * malloc (size_t __size ) throw () __attribute__ ((__malloc__ ) ) ; 
  extern "C" {
  }
  extern char * getenv (__const char * __name ) throw () __attribute__ ((__nonnull__ (1 ) ) ) ; 
  typedef int (* __compar_fn_t ) (__const void * , __const void * ) ; 
  typedef int (* __compar_d_fn_t ) (__const void * , __const void * , void * ) ; 
}
class wxObject ; 
class wxCommandEvent ; 
typedef void (* wxFunction ) (wxObject * , wxCommandEvent * ) ; 
typedef short int WXTYPE ; 
enum {
  wxFIRST_X11_CURSOR = 0 , wxCURSOR_ARROW = wxFIRST_X11_CURSOR , wxCURSOR_BASED_ARROW_DOWN , wxCURSOR_BASED_ARROW_UP , wxCURSOR_BULLSEYE , wxCURSOR_CROSS , wxCURSOR_CROSS_REVERSE , wxCURSOR_DOUBLE_ARROW , wxCURSOR_HAND , wxCURSOR_IBEAM , wxCURSOR_LEFT_BUTTON , wxCURSOR_MAGNIFIER , wxCURSOR_MIDDLE_BUTTON , wxCURSOR_NO_ENTRY , wxCURSOR_PAINT_BRUSH , wxCURSOR_PENCIL , wxCURSOR_POINT_LEFT , wxCURSOR_POINT_RIGHT , wxCURSOR_QUESTION_ARROW , wxCURSOR_RIGHT_BUTTON , wxCURSOR_SIZENESW , wxCURSOR_SIZENS , wxCURSOR_SIZENWSE , wxCURSOR_SIZEWE , wxCURSOR_SIZING , wxCURSOR_SPRAYCAN , wxCURSOR_WAIT , wxCURSOR_WATCH , wxLAST_X11_CURSOR = wxCURSOR_WATCH , wxCURSOR_START_PRIVATE = wxLAST_X11_CURSOR + 1 , wxCURSOR_CHAR , wxCURSOR_BLANK }
; 
enum {
  wxEVENT_TYPE_BUTTON_COMMAND = 0x0000 , wxEVENT_TYPE_CHECKBOX_COMMAND = 0x0001 , wxEVENT_TYPE_RESERVED1 = 0x0002 , wxEVENT_TYPE_CHOICE_COMMAND = 0x0003 , wxEVENT_TYPE_LISTBOX_COMMAND = 0x0004 , wxEVENT_TYPE_RESERVED2 = 0x0005 , wxEVENT_TYPE_TEXT_COMMAND = 0x0006 , wxEVENT_TYPE_MENU_POPDOWN_NONE = 0x0007 , wxEVENT_TYPE_MENU_COMMAND = 0x0008 , wxEVENT_TYPE_SLIDER_COMMAND = 0x0009 , wxEVENT_TYPE_RADIOBOX_COMMAND = 0x000a , wxEVENT_TYPE_TEXT_ENTER_COMMAND = 0x000b , wxEVENT_TYPE_SET_FOCUS = 0x000c , wxEVENT_TYPE_KILL_FOCUS = 0x000d , wxEVENT_TYPE_SCROLLBAR_COMMAND = 0x000e , wxEVENT_TYPE_MENU_POPDOWN = 0x000f , wxEVENT_TYPE_LISTBOX_DCLICK_COMMAND = 0x0010 , wxEVENT_TYPE_MENU_SELECT = 0x0011 , wxEVENT_TYPE_TAB_CHOICE_COMMAND = 0x0012 , wxEVENT_TYPE_SCROLL_TOP = 0x1000 , wxEVENT_TYPE_SCROLL_BOTTOM = 0x1001 , wxEVENT_TYPE_SCROLL_LINEUP = 0x1002 , wxEVENT_TYPE_SCROLL_LINEDOWN = 0x1003 , wxEVENT_TYPE_SCROLL_PAGEUP = 0x1004 , wxEVENT_TYPE_SCROLL_PAGEDOWN = 0x1005 , wxEVENT_TYPE_SCROLL_THUMBTRACK = 0x1006 , wxEVENT_TYPE_CHAR = 0x2000 , wxEVENT_TYPE_MOUSE = 0x3000 , wxEVENT_TYPE_LEFT = 0x3000 , wxEVENT_TYPE_MIDDLE = 0x3001 , wxEVENT_TYPE_RIGHT = 0x3002 , wxEVENT_TYPE_DOWN = 0x3010 , wxEVENT_TYPE_DOUBLE = 0x3100 , wxEVENT_TYPE_LEFT_DCLICK = 0x3110 , wxEVENT_TYPE_LEFT_DOWN = 0x3010 , wxEVENT_TYPE_LEFT_UP = 0x3000 , wxEVENT_TYPE_MIDDLE_DCLICK = 0x3111 , wxEVENT_TYPE_MIDDLE_DOWN = 0x3011 , wxEVENT_TYPE_MIDDLE_UP = 0x3001 , wxEVENT_TYPE_RIGHT_DCLICK = 0x3112 , wxEVENT_TYPE_RIGHT_DOWN = 0x3012 , wxEVENT_TYPE_RIGHT_UP = 0x3002 , wxEVENT_TYPE_MOTION = 0x3003 , wxEVENT_TYPE_ENTER_WINDOW = 0x3004 , wxEVENT_TYPE_LEAVE_WINDOW = 0x3005 }
; 
enum _Virtual_keycodes {
  WXK_BACK = 8 , WXK_TAB = 9 , WXK_RETURN = 13 , WXK_ESCAPE = 27 , WXK_SPACE = 32 , WXK_DELETE = 127 , WXK_START = 0xD800 , WXK_LBUTTON , WXK_RBUTTON , WXK_CANCEL , WXK_MBUTTON , WXK_CLEAR , WXK_SHIFT , WXK_CONTROL , WXK_MENU , WXK_PAUSE , WXK_CAPITAL , WXK_PRIOR , WXK_NEXT , WXK_END , WXK_HOME , WXK_LEFT , WXK_UP , WXK_RIGHT , WXK_DOWN , WXK_SELECT , WXK_PRINT , WXK_EXECUTE , WXK_SNAPSHOT , WXK_INSERT , WXK_HELP , WXK_NUMPAD0 , WXK_NUMPAD1 , WXK_NUMPAD2 , WXK_NUMPAD3 , WXK_NUMPAD4 , WXK_NUMPAD5 , WXK_NUMPAD6 , WXK_NUMPAD7 , WXK_NUMPAD8 , WXK_NUMPAD9 , WXK_MULTIPLY , WXK_ADD , WXK_SEPARATOR , WXK_SUBTRACT , WXK_DECIMAL , WXK_DIVIDE , WXK_F1 , WXK_F2 , WXK_F3 , WXK_F4 , WXK_F5 , WXK_F6 , WXK_F7 , WXK_F8 , WXK_F9 , WXK_F10 , WXK_F11 , WXK_F12 , WXK_F13 , WXK_F14 , WXK_F15 , WXK_F16 , WXK_F17 , WXK_F18 , WXK_F19 , WXK_F20 , WXK_F21 , WXK_F22 , WXK_F23 , WXK_F24 , WXK_NUMLOCK , WXK_SCROLL , WXK_WHEEL_UP , WXK_WHEEL_DOWN , WXK_PRESS , WXK_RELEASE }
; 
enum wxEdge {
  wxLeft , wxTop , wxRight , wxBottom , wxWidth , wxHeight , wxCentreX , wxCentreY }
; 
enum wxRelationship {
  wxUnconstrained = 0 , wxAsIs , wxPercentOf , wxAbove , wxBelow , wxLeftOf , wxRightOf , wxSameAs , wxAbsolute }
; 
class wxApp ; 
class wxBrush ; 
class wxBrushList ; 
class wxColour ; 
class wxColourDatabase ; 
class wxColourMap ; 
class wxCursor ; 
class wxFont ; 
class wxFontList ; 
class wxList ; 
class wxChildList ; 
class wxPen ; 
class wxPenList ; 
class wxPrintPaperDatabase ; 
class wxPrintSetupData ; 
class wxTypeTree ; 
class wxWindow ; 
extern char * wxAPP_CLASS ; 
extern char * wxAPP_NAME ; 
extern wxCursor * wxHOURGLASS_CURSOR ; 
class wxWindow ; 
extern "C" {
}
class wxCursor ; 
class wxCursor ; 
int wxExecute (char * * argv , int Async = 0 ) ; 
int wxExecute (const char * command , int Async = 0 ) ; 
int wxGetResource (const char * section , const char * entry , char * * value , const char * file = __null ) ; 
int wxGetResource (const char * section , const char * entry , float * value , const char * file = __null ) ; 
int wxGetResource (const char * section , const char * entry , long * value , const char * file = __null ) ; 
int wxGetResource (const char * section , const char * entry , int * value , const char * file = __null ) ; 
int wxWriteResource (const char * section , const char * entry , char * value , const char * file = __null ) ; 
int wxWriteResource (const char * section , const char * entry , float value , const char * file = __null ) ; 
int wxWriteResource (const char * section , const char * entry , long value , const char * file = __null ) ; 
int wxWriteResource (const char * section , const char * entry , int value , const char * file = __null ) ; 
enum GCPlacement {
  UseGC , AtomicGC }
; 
typedef void (* GCCleanUpFunc ) (void * obj , void * clientData ) ; 
extern "C" {
  void objscheme_mark_external_invalid (void * ) ; 
}
typedef int (* Size_Proc ) (void * obj ) ; 
typedef int (* Mark_Proc ) (void * obj ) ; 
typedef int (* Fixup_Proc ) (void * obj ) ; 
extern "C" {
  extern unsigned long (* GC_get_thread_stack_base ) (void ) ; 
  extern void (* GC_collect_start_callback ) (void ) ; 
  extern void (* GC_collect_end_callback ) (void ) ; 
  extern void (* GC_collect_inform_callback ) (int major_gc , long pre_used , long post_used ) ; 
  extern void (* GC_out_of_memory ) (void ) ; 
  extern void * GC_malloc (size_t size_in_bytes ) ; 
  extern void * GC_malloc_one_tagged (size_t ) ; 
  extern void (* GC_mark_xtagged ) (void * obj ) ; 
  extern void (* GC_fixup_xtagged ) (void * obj ) ; 
  extern void * GC_malloc_array_tagged (size_t ) ; 
  extern void * GC_malloc_atomic (size_t size_in_bytes ) ; 
  extern void * GC_malloc_atomic_uncollectable (size_t size_in_bytes ) ; 
  extern void * GC_malloc_allow_interior (size_t size_in_bytes ) ; 
  extern void * GC_malloc_atomic_allow_interior (size_t size_in_bytes ) ; 
  extern void * GC_malloc_tagged_allow_interior (size_t size_in_bytes ) ; 
  typedef void (* GC_finalization_proc ) (void * p , void * data ) ; 
  extern void GC_set_finalizer (void * p , int tagged , int level , GC_finalization_proc f , void * data , GC_finalization_proc * oldf , void * * olddata ) ; 
  extern void * * GC_variable_stack ; 
  extern void * * GC_get_variable_stack () ; 
  extern void GC_set_variable_stack (void * * p ) ; 
  extern void GC_register_traversers (short tag , Size_Proc size , Mark_Proc mark , Fixup_Proc fixup , int is_constant_size , int is_atomic ) ; 
  extern void * GC_resolve (void * p ) ; 
  extern void GC_mark (const void * p ) ; 
  extern void GC_fixup (void * p ) ; 
}
; 
extern "C" {
  void scheme_register_static (void * p , long size ) ; 
}
extern void * GC_cpp_malloc (size_t ) ; 
extern void GC_cpp_delete (class gc * ) ; 
class gc {
  public : inline virtual ~ gc () ; 
  inline void * operator new (size_t size ) ; 
  inline void * operator new (size_t size , GCPlacement gcp ) ; 
  inline void operator delete (void * obj ) ; 
  inline void * operator new [] (size_t size ) ; 
  inline void * operator new [] (size_t size , GCPlacement gcp ) ; 
  inline void operator delete [] (void * obj ) ; 
  virtual inline void gcMark () ; 
  virtual inline void gcFixup () ; 
  inline void gcInit_gc () {
  }
}
; 
class gc_cleanup : public gc {
  public : void * __gc_external ; 
  inline void gcInit_gc_cleanup () ; 
  inline void gcInit_gc_cleanup (int cleanup ) ; 
  inline virtual ~ gc_cleanup () ; 
  void install_cleanup () ; 
  inline void gcMark () ; 
  inline void gcFixup () ; 
}
; 
inline void gc :: gcMark () {
}
inline void gc :: gcFixup () {
}
inline void gc_cleanup :: gcMark () {
  GC_mark (__gc_external ) ; 
}
inline void gc_cleanup :: gcFixup () {
  GC_fixup (& (__gc_external ) ) ; 
}
inline void gc_cleanup :: gcInit_gc_cleanup (void ) {
  gc_cleanup * sElF = this ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sElF, 0)));
# define XfOrM1_COUNT (1)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1(_), sElF -> gcInit_gc () ); 
  (sElF -> __gc_external ) = __null ; 
  FUNCCALL_EMPTY(sElF -> install_cleanup () ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
inline void gc_cleanup :: gcInit_gc_cleanup (int cleanup ) {
  gc_cleanup * sElF = this ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sElF, 0)));
# define XfOrM2_COUNT (1)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM2(_), sElF -> gcInit_gc () ); 
  (sElF -> __gc_external ) = __null ; 
  if (cleanup )
    FUNCCALL_EMPTY(sElF -> install_cleanup () ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
inline gc_cleanup :: ~ gc_cleanup (void ) {
  if (__gc_external )
    objscheme_mark_external_invalid (__gc_external ) ; 
  GC_set_finalizer (this , 0 , 3 , 0 , 0 , 0 , 0 ) ; 
}
inline gc :: ~ gc (void ) {
}
inline void * gc :: operator new (size_t size ) {
  return GC_cpp_malloc (size ) ; 
}
inline void * gc :: operator new (size_t size , GCPlacement gcp ) {
  if (gcp == AtomicGC )
    return GC_malloc_atomic (size ) ; 
  return GC_cpp_malloc (size ) ; 
}
inline void gc :: operator delete (void * ) {
}
inline void * gc :: operator new [] (size_t size ) {
  return :: operator new (size ) ; 
}
inline void * gc :: operator new [] (size_t size , GCPlacement gcp ) {
  return gc :: operator new (size , gcp ) ; 
}
inline void gc :: operator delete [] (void * obj ) {
  gc :: operator delete (obj ) ; 
}
inline void * operator new (size_t size , GCPlacement gcp ) {
  void * obj ; 
  if (gcp == AtomicGC )
    obj = GC_malloc_atomic (size ) ; 
  else obj = GC_malloc (size ) ; 
  return obj ; 
}
inline void * operator new [] (size_t size , GCPlacement gcp ) {
  return :: operator new (size , gcp ) ; 
}
typedef struct {
  short tag ; 
  short filler_used_for_hashing ; 
  void * val ; 
}
wxWeak_Box ; 
class wxObject : public gc_cleanup {
  public : void gcInit_wxObject (void ) ; 
  void gcInit_wxObject (int cleanup ) ; 
  virtual ~ wxObject (void ) ; 
  WXTYPE __type ; 
  public : inline void gcMark () {
    gc_cleanup :: gcMark () ; 
  }
  inline void gcFixup () {
    gc_cleanup :: gcFixup () ; 
  }
}
; 
class wxFrame ; 
class wxApp : public wxObject {
  public : void gcInit_wxApp () ; 
  virtual void Dispatch (void ) ; 
  int Initialized (void ) {
    return initialized ; 
  }
  ; 
  virtual int MainLoop (void ) ; 
  virtual void ExitMainLoop (void ) {
    keep_going = 0 ; 
  }
  virtual wxFrame * OnInit (void ) {
    return 0 ; 
  }
  ; 
  virtual int OnExit (void ) {
    return 0 ; 
  }
  ; 
  virtual int Pending (void ) ; 
  char * GetAppName (void ) {
    return wxAPP_NAME ; 
  }
  void SetAppName (char * name ) {
    wxAPP_NAME = name ; 
  }
  char * GetClassName (void ) {
    return wxAPP_CLASS ; 
  }
  void SetClassName (char * name ) {
    wxAPP_CLASS = name ; 
  }
  int argc ; 
  char * * argv ; 
  private : friend int wxEntry (int argc , char * * argv ) ; 
  int initialized ; 
  public : int keep_going ; 
  public : inline void gcMark () {
    wxObject :: gcMark () ; 
    gcMARK_TYPED (char * * , argv ) ; 
  }
  inline void gcFixup () {
    wxObject :: gcFixup () ; 
    gcFIXUP_TYPED (char * * , argv ) ; 
  }
}
; 
extern int wxEntry (int argc , char * argv [] ) ; 
extern int wxGetPreference (const char * name , int * res ) ; 
class wxStandardSnipClassList ; 
class wxBufferDataClassList ; 
extern "C" {
  typedef int __jmp_buf [6 ] ; 
  struct __jmp_buf_tag {
    __jmp_buf __jmpbuf ; 
    int __mask_was_saved ; 
    __sigset_t __saved_mask ; 
  }
  ; 
  typedef struct __jmp_buf_tag jmp_buf [1 ] ; 
  extern int _setjmp (struct __jmp_buf_tag __env [1 ] ) throw () ; 
  typedef struct __jmp_buf_tag sigjmp_buf [1 ] ; 
}
extern "C" {
  typedef short Scheme_Type ; 
  typedef int mzshort ; 
  typedef unsigned int mzchar ; 
  typedef long long mzlonglong ; 
  typedef unsigned long long umzlonglong ; 
  typedef struct Scheme_Object {
    Scheme_Type type ; 
    short keyex ; 
  }
  Scheme_Object ; 
  typedef struct Scheme_Inclhash_Object {
    Scheme_Object so ; 
  }
  Scheme_Inclhash_Object ; 
  typedef struct Scheme_Simple_Object {
    Scheme_Inclhash_Object iso ; 
    union {
      struct {
        mzchar * string_val ; 
        int tag_val ; 
      }
      char_str_val ; 
      struct {
        char * string_val ; 
        int tag_val ; 
      }
      byte_str_val ; 
      struct {
        void * ptr1 , * ptr2 ; 
      }
      two_ptr_val ; 
      struct {
        int int1 ; 
        int int2 ; 
      }
      two_int_val ; 
      struct {
        void * ptr ; 
        int pint ; 
      }
      ptr_int_val ; 
      struct {
        void * ptr ; 
        long pint ; 
      }
      ptr_long_val ; 
      struct {
        struct Scheme_Object * car , * cdr ; 
      }
      pair_val ; 
      struct {
        mzshort len ; 
        mzshort * vec ; 
      }
      svector_val ; 
      struct {
        void * val ; 
        Scheme_Object * type ; 
      }
      cptr_val ; 
    }
    u ; 
  }
  Scheme_Simple_Object ; 
  typedef struct Scheme_Object * (* Scheme_Closure_Func ) (struct Scheme_Object * ) ; 
  typedef struct {
    Scheme_Inclhash_Object iso ; 
    union {
      mzchar char_val ; 
      Scheme_Object * ptr_value ; 
      long int_val ; 
      Scheme_Object * ptr_val ; 
    }
    u ; 
  }
  Scheme_Small_Object ; 
  typedef struct {
    Scheme_Object so ; 
    double double_val ; 
  }
  Scheme_Double ; 
  typedef struct Scheme_Symbol {
    Scheme_Inclhash_Object iso ; 
    int len ; 
    char s [4 ] ; 
  }
  Scheme_Symbol ; 
  typedef struct Scheme_Vector {
    Scheme_Inclhash_Object iso ; 
    int size ; 
    Scheme_Object * els [1 ] ; 
  }
  Scheme_Vector ; 
  typedef struct Scheme_Print_Params Scheme_Print_Params ; 
  typedef void (* Scheme_Type_Printer ) (Scheme_Object * v , int for_display , Scheme_Print_Params * pp ) ; 
  typedef int (* Scheme_Equal_Proc ) (Scheme_Object * obj1 , Scheme_Object * obj2 , void * cycle_data ) ; 
  typedef long (* Scheme_Primary_Hash_Proc ) (Scheme_Object * obj , long base , void * cycle_data ) ; 
  typedef long (* Scheme_Secondary_Hash_Proc ) (Scheme_Object * obj , void * cycle_data ) ; 
  enum {
    scheme_toplevel_type , scheme_local_type , scheme_local_unbox_type , scheme_syntax_type , scheme_application_type , scheme_application2_type , scheme_application3_type , scheme_sequence_type , scheme_branch_type , scheme_unclosed_procedure_type , scheme_let_value_type , scheme_let_void_type , scheme_letrec_type , scheme_let_one_type , scheme_with_cont_mark_type , scheme_quote_syntax_type , _scheme_values_types_ , scheme_compiled_unclosed_procedure_type , scheme_compiled_let_value_type , scheme_compiled_let_void_type , scheme_compiled_syntax_type , scheme_compiled_toplevel_type , scheme_compiled_quote_syntax_type , scheme_quote_compilation_type , scheme_variable_type , scheme_module_variable_type , _scheme_compiled_values_types_ , scheme_prim_type , scheme_closed_prim_type , scheme_closure_type , scheme_case_closure_type , scheme_cont_type , scheme_escaping_cont_type , scheme_proc_struct_type , scheme_native_closure_type , scheme_structure_type , scheme_char_type , scheme_integer_type , scheme_bignum_type , scheme_rational_type , scheme_float_type , scheme_double_type , scheme_complex_type , scheme_char_string_type , scheme_byte_string_type , scheme_unix_path_type , scheme_windows_path_type , scheme_symbol_type , scheme_keyword_type , scheme_null_type , scheme_pair_type , scheme_mutable_pair_type , scheme_vector_type , scheme_inspector_type , scheme_input_port_type , scheme_output_port_type , scheme_eof_type , scheme_true_type , scheme_false_type , scheme_void_type , scheme_syntax_compiler_type , scheme_macro_type , scheme_box_type , scheme_thread_type , scheme_stx_offset_type , scheme_cont_mark_set_type , scheme_sema_type , scheme_hash_table_type , scheme_hash_tree_type , scheme_cpointer_type , scheme_offset_cpointer_type , scheme_weak_box_type , scheme_ephemeron_type , scheme_struct_type_type , scheme_module_index_type , scheme_set_macro_type , scheme_listener_type , scheme_namespace_type , scheme_config_type , scheme_stx_type , scheme_will_executor_type , scheme_custodian_type , scheme_random_state_type , scheme_regexp_type , scheme_bucket_type , scheme_bucket_table_type , scheme_subprocess_type , scheme_compilation_top_type , scheme_wrap_chunk_type , scheme_eval_waiting_type , scheme_tail_call_waiting_type , scheme_undefined_type , scheme_struct_property_type , scheme_multiple_values_type , scheme_placeholder_type , scheme_table_placeholder_type , scheme_case_lambda_sequence_type , scheme_begin0_sequence_type , scheme_rename_table_type , scheme_rename_table_set_type , scheme_module_type , scheme_svector_type , scheme_lazy_macro_type , scheme_resolve_prefix_type , scheme_security_guard_type , scheme_indent_type , scheme_udp_type , scheme_udp_evt_type , scheme_tcp_accept_evt_type , scheme_id_macro_type , scheme_evt_set_type , scheme_wrap_evt_type , scheme_handle_evt_type , scheme_nack_guard_evt_type , scheme_semaphore_repost_type , scheme_channel_type , scheme_channel_put_type , scheme_thread_resume_type , scheme_thread_suspend_type , scheme_thread_dead_type , scheme_poll_evt_type , scheme_nack_evt_type , scheme_module_registry_type , scheme_thread_set_type , scheme_string_converter_type , scheme_alarm_type , scheme_thread_recv_evt_type , scheme_thread_cell_type , scheme_channel_syncer_type , scheme_special_comment_type , scheme_write_evt_type , scheme_always_evt_type , scheme_never_evt_type , scheme_progress_evt_type , scheme_certifications_type , scheme_already_comp_type , scheme_readtable_type , scheme_intdef_context_type , scheme_lexical_rib_type , scheme_thread_cell_values_type , scheme_global_ref_type , scheme_cont_mark_chain_type , scheme_raw_pair_type , scheme_prompt_type , scheme_prompt_tag_type , scheme_expanded_syntax_type , scheme_delay_syntax_type , scheme_cust_box_type , scheme_resolved_module_path_type , scheme_module_phase_exports_type , scheme_logger_type , scheme_log_reader_type , _scheme_last_normal_type_ , scheme_rt_weak_array , scheme_rt_comp_env , scheme_rt_constant_binding , scheme_rt_resolve_info , scheme_rt_optimize_info , scheme_rt_compile_info , scheme_rt_cont_mark , scheme_rt_saved_stack , scheme_rt_reply_item , scheme_rt_closure_info , scheme_rt_overflow , scheme_rt_overflow_jmp , scheme_rt_meta_cont , scheme_rt_dyn_wind_cell , scheme_rt_dyn_wind_info , scheme_rt_dyn_wind , scheme_rt_dup_check , scheme_rt_thread_memory , scheme_rt_input_file , scheme_rt_input_fd , scheme_rt_oskit_console_input , scheme_rt_tested_input_file , scheme_rt_tested_output_file , scheme_rt_indexed_string , scheme_rt_output_file , scheme_rt_load_handler_data , scheme_rt_pipe , scheme_rt_beos_process , scheme_rt_system_child , scheme_rt_tcp , scheme_rt_write_data , scheme_rt_tcp_select_info , scheme_rt_namespace_option , scheme_rt_param_data , scheme_rt_will , scheme_rt_struct_proc_info , scheme_rt_linker_name , scheme_rt_param_map , scheme_rt_finalization , scheme_rt_finalizations , scheme_rt_cpp_object , scheme_rt_cpp_array_object , scheme_rt_stack_object , scheme_rt_preallocated_object , scheme_thread_hop_type , scheme_rt_srcloc , scheme_rt_evt , scheme_rt_syncing , scheme_rt_comp_prefix , scheme_rt_user_input , scheme_rt_user_output , scheme_rt_compact_port , scheme_rt_read_special_dw , scheme_rt_regwork , scheme_rt_buf_holder , scheme_rt_parameterization , scheme_rt_print_params , scheme_rt_read_params , scheme_rt_native_code , scheme_rt_native_code_plus_case , scheme_rt_jitter_data , scheme_rt_module_exports , scheme_rt_delay_load_info , scheme_rt_marshal_info , scheme_rt_unmarshal_info , scheme_rt_runstack , scheme_rt_sfs_info , scheme_rt_validate_clearing , scheme_rt_rb_node , _scheme_last_type_ }
  ; 
  typedef struct Scheme_Cptr {
    Scheme_Object so ; 
    void * val ; 
    Scheme_Object * type ; 
  }
  Scheme_Cptr ; 
  typedef struct Scheme_Offset_Cptr {
    Scheme_Cptr cptr ; 
    long offset ; 
  }
  Scheme_Offset_Cptr ; 
  typedef struct Scheme_Object * (Scheme_Prim ) (int argc , Scheme_Object * argv [] ) ; 
  typedef struct Scheme_Object * (Scheme_Primitive_Closure_Proc ) (int argc , struct Scheme_Object * argv [] , Scheme_Object * p ) ; 
  typedef struct {
    Scheme_Object so ; 
    unsigned short flags ; 
  }
  Scheme_Prim_Proc_Header ; 
  typedef struct {
    Scheme_Prim_Proc_Header pp ; 
    Scheme_Primitive_Closure_Proc * prim_val ; 
    const char * name ; 
    mzshort mina ; 
    union {
      mzshort * cases ; 
      mzshort maxa ; 
    }
    mu ; 
  }
  Scheme_Primitive_Proc ; 
  typedef struct {
    Scheme_Primitive_Proc pp ; 
    mzshort minr , maxr ; 
  }
  Scheme_Prim_W_Result_Arity ; 
  typedef struct Scheme_Primitive_Closure {
    Scheme_Primitive_Proc p ; 
    mzshort count ; 
    Scheme_Object * val [1 ] ; 
  }
  Scheme_Primitive_Closure ; 
  typedef struct Scheme_Object * (Scheme_Closed_Prim ) (void * d , int argc , struct Scheme_Object * argv [] ) ; 
  typedef struct {
    Scheme_Prim_Proc_Header pp ; 
    Scheme_Closed_Prim * prim_val ; 
    void * data ; 
    const char * name ; 
    mzshort mina , maxa ; 
  }
  Scheme_Closed_Primitive_Proc ; 
  typedef struct {
    Scheme_Closed_Primitive_Proc p ; 
    mzshort * cases ; 
  }
  Scheme_Closed_Case_Primitive_Proc ; 
  typedef struct {
    Scheme_Closed_Primitive_Proc p ; 
    mzshort minr , maxr ; 
  }
  Scheme_Closed_Prim_W_Result_Arity ; 
  typedef struct Scheme_Hash_Table {
    Scheme_Inclhash_Object iso ; 
    int size ; 
    int count ; 
    Scheme_Object * * keys ; 
    Scheme_Object * * vals ; 
    void (* make_hash_indices ) (void * v , long * h1 , long * h2 ) ; 
    int (* compare ) (void * v1 , void * v2 ) ; 
    Scheme_Object * mutex ; 
    int mcount ; 
  }
  Scheme_Hash_Table ; 
  typedef struct Scheme_Hash_Tree Scheme_Hash_Tree ; 
  typedef struct Scheme_Bucket {
    Scheme_Object so ; 
    void * val ; 
    char * key ; 
  }
  Scheme_Bucket ; 
  typedef struct Scheme_Bucket_Table {
    Scheme_Object so ; 
    int size ; 
    int count ; 
    Scheme_Bucket * * buckets ; 
    char weak , with_home ; 
    void (* make_hash_indices ) (void * v , long * h1 , long * h2 ) ; 
    int (* compare ) (void * v1 , void * v2 ) ; 
    Scheme_Object * mutex ; 
  }
  Scheme_Bucket_Table ; 
  enum {
    SCHEME_hash_string , SCHEME_hash_ptr , SCHEME_hash_bound_id , SCHEME_hash_weak_ptr }
  ; 
  typedef struct Scheme_Env Scheme_Env ; 
  typedef struct {
    jmp_buf jb ; 
    unsigned long stack_frame ; 
  }
  mz_one_jit_jmp_buf ; 
  typedef mz_one_jit_jmp_buf mz_jit_jmp_buf [1 ] ; 
  typedef struct {
    mz_jit_jmp_buf jb ; 
    long gcvs ; 
    long gcvs_cnt ; 
  }
  mz_jmp_buf ; 
  typedef struct Scheme_Jumpup_Buf {
    void * stack_from , * stack_copy ; 
    long stack_size , stack_max_size ; 
    struct Scheme_Cont * cont ; 
    mz_jmp_buf buf ; 
    void * gc_var_stack ; 
    void * external_stack ; 
  }
  Scheme_Jumpup_Buf ; 
  typedef struct Scheme_Jumpup_Buf_Holder {
    Scheme_Type type ; 
    Scheme_Jumpup_Buf buf ; 
  }
  Scheme_Jumpup_Buf_Holder ; 
  typedef struct Scheme_Continuation_Jump_State {
    struct Scheme_Object * jumping_to_continuation ; 
    Scheme_Object * val ; 
    mzshort num_vals ; 
    short is_kill , is_escape ; 
  }
  Scheme_Continuation_Jump_State ; 
  typedef struct Scheme_Cont_Frame_Data {
    long cont_mark_pos ; 
    long cont_mark_stack ; 
    void * cache ; 
  }
  Scheme_Cont_Frame_Data ; 
  typedef void (Scheme_Close_Custodian_Client ) (Scheme_Object * o , void * data ) ; 
  typedef void (* Scheme_Exit_Closer_Func ) (Scheme_Object * , Scheme_Close_Custodian_Client * , void * ) ; 
  typedef Scheme_Object * (* Scheme_Custodian_Extractor ) (Scheme_Object * o ) ; 
  typedef struct Scheme_Object Scheme_Custodian_Reference ; 
  typedef struct Scheme_Custodian Scheme_Custodian ; 
  typedef Scheme_Bucket_Table Scheme_Thread_Cell_Table ; 
  typedef struct Scheme_Config Scheme_Config ; 
  typedef int (* Scheme_Ready_Fun ) (Scheme_Object * o ) ; 
  typedef void (* Scheme_Needs_Wakeup_Fun ) (Scheme_Object * , void * ) ; 
  typedef Scheme_Object * (* Scheme_Sync_Sema_Fun ) (Scheme_Object * , int * repost ) ; 
  typedef int (* Scheme_Sync_Filter_Fun ) (Scheme_Object * ) ; 
  typedef struct Scheme_Thread {
    Scheme_Object so ; 
    struct Scheme_Thread * next ; 
    struct Scheme_Thread * prev ; 
    struct Scheme_Thread_Set * t_set_parent ; 
    Scheme_Object * t_set_next ; 
    Scheme_Object * t_set_prev ; 
    mz_jmp_buf * error_buf ; 
    Scheme_Continuation_Jump_State cjs ; 
    struct Scheme_Meta_Continuation * decompose_mc ; 
    Scheme_Thread_Cell_Table * cell_values ; 
    Scheme_Config * init_config ; 
    Scheme_Object * init_break_cell ; 
    int can_break_at_swap ; 
    Scheme_Object * * runstack ; 
    Scheme_Object * * runstack_start ; 
    long runstack_size ; 
    struct Scheme_Saved_Stack * runstack_saved ; 
    Scheme_Object * * runstack_tmp_keep ; 
    Scheme_Object * * spare_runstack ; 
    long spare_runstack_size ; 
    struct Scheme_Thread * * runstack_owner ; 
    struct Scheme_Saved_Stack * runstack_swapped ; 
    long cont_mark_pos ; 
    long cont_mark_stack ; 
    struct Scheme_Cont_Mark * * cont_mark_stack_segments ; 
    int cont_mark_seg_count ; 
    int cont_mark_stack_bottom ; 
    int cont_mark_pos_bottom ; 
    struct Scheme_Thread * * cont_mark_stack_owner ; 
    struct Scheme_Cont_Mark * cont_mark_stack_swapped ; 
    struct Scheme_Prompt * meta_prompt ; 
    struct Scheme_Meta_Continuation * meta_continuation ; 
    long engine_weight ; 
    void * stack_start ; 
    void * stack_end ; 
    Scheme_Jumpup_Buf jmpup_buf ; 
    struct Scheme_Dynamic_Wind * dw ; 
    int next_meta ; 
    int running ; 
    Scheme_Object * suspended_box ; 
    Scheme_Object * resumed_box ; 
    Scheme_Object * dead_box ; 
    Scheme_Object * running_box ; 
    struct Scheme_Thread * nester , * nestee ; 
    double sleep_end ; 
    int block_descriptor ; 
    Scheme_Object * blocker ; 
    Scheme_Ready_Fun block_check ; 
    Scheme_Needs_Wakeup_Fun block_needs_wakeup ; 
    char ran_some ; 
    char suspend_to_kill ; 
    struct Scheme_Overflow * overflow ; 
    struct Scheme_Comp_Env * current_local_env ; 
    Scheme_Object * current_local_mark ; 
    Scheme_Object * current_local_name ; 
    Scheme_Object * current_local_certs ; 
    Scheme_Object * current_local_modidx ; 
    Scheme_Env * current_local_menv ; 
    Scheme_Object * current_local_bindings ; 
    int current_phase_shift ; 
    struct Scheme_Marshal_Tables * current_mt ; 
    Scheme_Object * constant_folding ; 
    Scheme_Object * (* overflow_k ) (void ) ; 
    Scheme_Object * overflow_reply ; 
    Scheme_Object * * tail_buffer ; 
    int tail_buffer_size ; 
    Scheme_Object * * values_buffer ; 
    int values_buffer_size ; 
    struct {
      struct {
        Scheme_Object * wait_expr ; 
      }
      eval ; 
      struct {
        Scheme_Object * tail_rator ; 
        Scheme_Object * * tail_rands ; 
        long tail_num_rands ; 
      }
      apply ; 
      struct {
        Scheme_Object * * array ; 
        long count ; 
      }
      multiple ; 
      struct {
        void * p1 , * p2 , * p3 , * p4 , * p5 ; 
        long i1 , i2 , i3 , i4 ; 
      }
      k ; 
    }
    ku ; 
    short suspend_break ; 
    short external_break ; 
    Scheme_Simple_Object * list_stack ; 
    int list_stack_pos ; 
    void (* on_kill ) (struct Scheme_Thread * p ) ; 
    void * kill_data ; 
    void (* private_on_kill ) (void * ) ; 
    void * private_kill_data ; 
    void * * private_kill_next ; 
    void * * user_tls ; 
    int user_tls_size ; 
    long gmp_tls [6 ] ; 
    struct Scheme_Thread_Custodian_Hop * mr_hop ; 
    Scheme_Custodian_Reference * mref ; 
    Scheme_Object * extra_mrefs ; 
    Scheme_Object * transitive_resumes ; 
    Scheme_Object * name ; 
    Scheme_Object * mbox_first ; 
    Scheme_Object * mbox_last ; 
    Scheme_Object * mbox_sema ; 
    struct gc_thread_info * gc_info ; 
  }
  Scheme_Thread ; 
  typedef void (* Scheme_Kill_Action_Func ) (void * ) ; 
  enum {
    MZCONFIG_ENV , MZCONFIG_INPUT_PORT , MZCONFIG_OUTPUT_PORT , MZCONFIG_ERROR_PORT , MZCONFIG_ERROR_DISPLAY_HANDLER , MZCONFIG_ERROR_PRINT_VALUE_HANDLER , MZCONFIG_EXIT_HANDLER , MZCONFIG_INIT_EXN_HANDLER , MZCONFIG_EVAL_HANDLER , MZCONFIG_COMPILE_HANDLER , MZCONFIG_LOAD_HANDLER , MZCONFIG_LOAD_COMPILED_HANDLER , MZCONFIG_PRINT_HANDLER , MZCONFIG_PROMPT_READ_HANDLER , MZCONFIG_READTABLE , MZCONFIG_READER_GUARD , MZCONFIG_CAN_READ_GRAPH , MZCONFIG_CAN_READ_COMPILED , MZCONFIG_CAN_READ_BOX , MZCONFIG_CAN_READ_PIPE_QUOTE , MZCONFIG_CAN_READ_DOT , MZCONFIG_CAN_READ_INFIX_DOT , MZCONFIG_CAN_READ_QUASI , MZCONFIG_CAN_READ_READER , MZCONFIG_READ_DECIMAL_INEXACT , MZCONFIG_PRINT_GRAPH , MZCONFIG_PRINT_STRUCT , MZCONFIG_PRINT_BOX , MZCONFIG_PRINT_VEC_SHORTHAND , MZCONFIG_PRINT_HASH_TABLE , MZCONFIG_PRINT_UNREADABLE , MZCONFIG_PRINT_PAIR_CURLY , MZCONFIG_PRINT_MPAIR_CURLY , MZCONFIG_CASE_SENS , MZCONFIG_SQUARE_BRACKETS_ARE_PARENS , MZCONFIG_CURLY_BRACES_ARE_PARENS , MZCONFIG_HONU_MODE , MZCONFIG_ERROR_PRINT_WIDTH , MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH , MZCONFIG_ERROR_ESCAPE_HANDLER , MZCONFIG_ALLOW_SET_UNDEFINED , MZCONFIG_COMPILE_MODULE_CONSTS , MZCONFIG_USE_JIT , MZCONFIG_CUSTODIAN , MZCONFIG_INSPECTOR , MZCONFIG_CODE_INSPECTOR , MZCONFIG_USE_COMPILED_KIND , MZCONFIG_USE_USER_PATHS , MZCONFIG_LOAD_DIRECTORY , MZCONFIG_WRITE_DIRECTORY , MZCONFIG_COLLECTION_PATHS , MZCONFIG_PORT_PRINT_HANDLER , MZCONFIG_LOAD_EXTENSION_HANDLER , MZCONFIG_CURRENT_DIRECTORY , MZCONFIG_RANDOM_STATE , MZCONFIG_CURRENT_MODULE_RESOLVER , MZCONFIG_CURRENT_MODULE_NAME , MZCONFIG_ERROR_PRINT_SRCLOC , MZCONFIG_CMDLINE_ARGS , MZCONFIG_LOCALE , MZCONFIG_SECURITY_GUARD , MZCONFIG_PORT_COUNT_LINES , MZCONFIG_SCHEDULER_RANDOM_STATE , MZCONFIG_THREAD_SET , MZCONFIG_THREAD_INIT_STACK_SIZE , MZCONFIG_LOAD_DELAY_ENABLED , MZCONFIG_DELAY_LOAD_INFO , MZCONFIG_EXPAND_OBSERVE , MZCONFIG_LOGGER , __MZCONFIG_BUILTIN_COUNT__ }
  ; 
  typedef struct Scheme_Input_Port Scheme_Input_Port ; 
  typedef struct Scheme_Output_Port Scheme_Output_Port ; 
  typedef struct Scheme_Port Scheme_Port ; 
  typedef long (* Scheme_Get_String_Fun ) (Scheme_Input_Port * port , char * buffer , long offset , long size , int nonblock , Scheme_Object * unless ) ; 
  typedef long (* Scheme_Peek_String_Fun ) (Scheme_Input_Port * port , char * buffer , long offset , long size , Scheme_Object * skip , int nonblock , Scheme_Object * unless ) ; 
  typedef Scheme_Object * (* Scheme_Progress_Evt_Fun ) (Scheme_Input_Port * port ) ; 
  typedef int (* Scheme_Peeked_Read_Fun ) (Scheme_Input_Port * port , long amount , Scheme_Object * unless_evt , Scheme_Object * target_ch ) ; 
  typedef int (* Scheme_In_Ready_Fun ) (Scheme_Input_Port * port ) ; 
  typedef void (* Scheme_Close_Input_Fun ) (Scheme_Input_Port * port ) ; 
  typedef void (* Scheme_Need_Wakeup_Input_Fun ) (Scheme_Input_Port * , void * ) ; 
  typedef Scheme_Object * (* Scheme_Location_Fun ) (Scheme_Port * ) ; 
  typedef void (* Scheme_Count_Lines_Fun ) (Scheme_Port * ) ; 
  typedef int (* Scheme_Buffer_Mode_Fun ) (Scheme_Port * , int m ) ; 
  typedef Scheme_Object * (* Scheme_Write_String_Evt_Fun ) (Scheme_Output_Port * , const char * str , long offset , long size ) ; 
  typedef long (* Scheme_Write_String_Fun ) (Scheme_Output_Port * , const char * str , long offset , long size , int rarely_block , int enable_break ) ; 
  typedef int (* Scheme_Out_Ready_Fun ) (Scheme_Output_Port * port ) ; 
  typedef void (* Scheme_Close_Output_Fun ) (Scheme_Output_Port * port ) ; 
  typedef void (* Scheme_Need_Wakeup_Output_Fun ) (Scheme_Output_Port * , void * ) ; 
  typedef Scheme_Object * (* Scheme_Write_Special_Evt_Fun ) (Scheme_Output_Port * , Scheme_Object * ) ; 
  typedef int (* Scheme_Write_Special_Fun ) (Scheme_Output_Port * , Scheme_Object * , int nonblock ) ; 
  struct Scheme_Port {
    Scheme_Object so ; 
    char count_lines , was_cr ; 
    long position , readpos , lineNumber , charsSinceNewline ; 
    long column , oldColumn ; 
    int utf8state ; 
    Scheme_Location_Fun location_fun ; 
    Scheme_Count_Lines_Fun count_lines_fun ; 
    Scheme_Buffer_Mode_Fun buffer_mode_fun ; 
  }
  ; 
  struct Scheme_Input_Port {
    struct Scheme_Port p ; 
    char closed , pending_eof ; 
    Scheme_Object * sub_type ; 
    Scheme_Custodian_Reference * mref ; 
    void * port_data ; 
    Scheme_Get_String_Fun get_string_fun ; 
    Scheme_Peek_String_Fun peek_string_fun ; 
    Scheme_Progress_Evt_Fun progress_evt_fun ; 
    Scheme_Peeked_Read_Fun peeked_read_fun ; 
    Scheme_In_Ready_Fun byte_ready_fun ; 
    Scheme_Close_Input_Fun close_fun ; 
    Scheme_Need_Wakeup_Input_Fun need_wakeup_fun ; 
    Scheme_Object * read_handler ; 
    Scheme_Object * name ; 
    Scheme_Object * peeked_read , * peeked_write ; 
    Scheme_Object * progress_evt , * input_lock , * input_giveup , * input_extras , * input_extras_ready ; 
    unsigned char ungotten [24 ] ; 
    int ungotten_count ; 
    Scheme_Object * special , * ungotten_special ; 
    Scheme_Object * unless , * unless_cache ; 
    struct Scheme_Output_Port * output_half ; 
  }
  ; 
  struct Scheme_Output_Port {
    struct Scheme_Port p ; 
    short closed ; 
    Scheme_Object * sub_type ; 
    Scheme_Custodian_Reference * mref ; 
    void * port_data ; 
    Scheme_Write_String_Evt_Fun write_string_evt_fun ; 
    Scheme_Write_String_Fun write_string_fun ; 
    Scheme_Close_Output_Fun close_fun ; 
    Scheme_Out_Ready_Fun ready_fun ; 
    Scheme_Need_Wakeup_Output_Fun need_wakeup_fun ; 
    Scheme_Write_Special_Evt_Fun write_special_evt_fun ; 
    Scheme_Write_Special_Fun write_special_fun ; 
    long pos ; 
    Scheme_Object * name ; 
    Scheme_Object * display_handler ; 
    Scheme_Object * write_handler ; 
    Scheme_Object * print_handler ; 
    struct Scheme_Input_Port * input_half ; 
  }
  ; 
  enum {
    MZEXN , MZEXN_FAIL , MZEXN_FAIL_CONTRACT , MZEXN_FAIL_CONTRACT_ARITY , MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , MZEXN_FAIL_CONTRACT_CONTINUATION , MZEXN_FAIL_CONTRACT_VARIABLE , MZEXN_FAIL_SYNTAX , MZEXN_FAIL_READ , MZEXN_FAIL_READ_EOF , MZEXN_FAIL_READ_NON_CHAR , MZEXN_FAIL_FILESYSTEM , MZEXN_FAIL_FILESYSTEM_EXISTS , MZEXN_FAIL_FILESYSTEM_VERSION , MZEXN_FAIL_NETWORK , MZEXN_FAIL_OUT_OF_MEMORY , MZEXN_FAIL_UNSUPPORTED , MZEXN_FAIL_USER , MZEXN_BREAK , MZEXN_OTHER }
  ; 
  typedef struct Scheme_Logger Scheme_Logger ; 
  typedef void (* Scheme_Invoke_Proc ) (Scheme_Env * env , long phase_shift , Scheme_Object * self_modidx , void * data ) ; 
  extern volatile int scheme_fuel_counter ; 
  extern void scheme_jit_setjmp_prepare (mz_jit_jmp_buf b ) ; 
  extern void scheme_set_binary_mode_stdio (int ) ; 
  extern void scheme_set_startup_use_jit (int ) ; 
  extern void scheme_set_startup_load_on_demand (int ) ; 
  extern void scheme_set_ignore_user_paths (int ) ; 
  extern void scheme_set_logging (int syslog_level , int stderr_level ) ; 
  extern Scheme_Thread * scheme_current_thread ; 
  typedef void (* Scheme_Exit_Proc ) (int v ) ; 
  typedef void (* scheme_console_printf_t ) (char * str , ... ) ; 
  extern void (* scheme_console_output ) (char * str , long len ) ; 
  extern void (* scheme_sleep ) (float seconds , void * fds ) ; 
  extern void (* scheme_notify_multithread ) (int on ) ; 
  extern void (* scheme_wakeup_on_input ) (void * fds ) ; 
  extern int (* scheme_check_for_break ) (void ) ; 
  extern Scheme_Object * (* scheme_module_demand_hook ) (int c , Scheme_Object * * a ) ; 
  extern void * (* scheme_get_external_stack_val ) (void ) ; 
  extern void (* scheme_set_external_stack_val ) (void * ) ; 
  extern Scheme_Object * (* scheme_make_stdin ) (void ) ; 
  extern Scheme_Object * (* scheme_make_stdout ) (void ) ; 
  extern Scheme_Object * (* scheme_make_stderr ) (void ) ; 
  extern Scheme_Object * scheme_set_exec_cmd (char * s ) ; 
  extern Scheme_Object * scheme_set_run_cmd (char * s ) ; 
  extern void scheme_set_collects_path (Scheme_Object * p ) ; 
  extern void scheme_init_collection_paths (Scheme_Env * global_env , Scheme_Object * extra_dirs ) ; 
  typedef int (* Scheme_Nested_Main ) (void * data ) ; 
  extern int scheme_main_stack_setup (int no_auto_statics , Scheme_Nested_Main _main , void * data ) ; 
  typedef int (* Scheme_Env_Main ) (Scheme_Env * env , int argc , char * * argv ) ; 
  extern void scheme_register_static (void * ptr , long size ) ; 
  extern void (* scheme_on_atomic_timeout ) (void ) ; 
  struct mz_addrinfo {
    int ai_flags ; 
    int ai_family ; 
    int ai_socktype ; 
    int ai_protocol ; 
    size_t ai_addrlen ; 
    struct sockaddr * ai_addr ; 
    struct mz_addrinfo * ai_next ; 
  }
  ; 
  extern Scheme_Config * scheme_current_config (void ) ; 
  extern Scheme_Object * scheme_get_param (Scheme_Config * c , int pos ) ; 
  extern void scheme_set_param (Scheme_Config * c , int pos , Scheme_Object * o ) ; 
  extern Scheme_Thread * scheme_current_thread ; 
  extern volatile int scheme_fuel_counter ; 
  extern Scheme_Thread * scheme_get_current_thread () ; 
  extern void scheme_set_can_break (int on ) ; 
  extern void scheme_signal_error (const char * msg , ... ) ; 
  extern Scheme_Object scheme_eof [1 ] ; 
  extern Scheme_Object scheme_null [1 ] ; 
  extern Scheme_Object * scheme_make_null (void ) ; 
  extern Scheme_Object scheme_true [1 ] ; 
  extern Scheme_Object scheme_false [1 ] ; 
  extern Scheme_Object * scheme_make_false (void ) ; 
  extern Scheme_Object scheme_void [1 ] ; 
  extern Scheme_Object scheme_undefined [1 ] ; 
  extern unsigned short * scheme_uchar_table [] ; 
  extern unsigned char * scheme_uchar_cases_table [] ; 
  extern unsigned char * scheme_uchar_cats_table [] ; 
  extern int scheme_uchar_ups [] ; 
  extern int scheme_uchar_downs [] ; 
  extern int scheme_uchar_titles [] ; 
  extern int scheme_uchar_folds [] ; 
  extern unsigned char scheme_uchar_combining_classes [] ; 
  extern Scheme_Object * scheme_eval_multi_with_prompt (Scheme_Object * obj , Scheme_Env * env ) ; 
  extern Scheme_Object * scheme_apply (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) ; 
  extern Scheme_Object * scheme_apply_multi (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) ; 
  extern Scheme_Object * scheme_eval_string_all_with_prompt (const char * str , Scheme_Env * env , int all ) ; 
  extern void scheme_detach_multple_array (Scheme_Object * * a ) ; 
  extern void * GC_malloc (size_t size_in_bytes ) ; 
  extern void * GC_malloc_atomic (size_t size_in_bytes ) ; 
  extern void * GC_malloc_one_tagged (size_t size_in_bytes ) ; 
  extern void * GC_malloc_atomic_uncollectable (size_t size_in_bytes ) ; 
  extern void * GC_malloc_array_tagged (size_t size_in_bytes ) ; 
  extern void * GC_malloc_allow_interior (size_t size_in_bytes ) ; 
  extern void * GC_malloc_atomic_allow_interior (size_t size_in_bytes ) ; 
  extern void * GC_malloc_tagged_allow_interior (size_t size_in_bytes ) ; 
  extern void * * GC_variable_stack ; 
  extern void GC_register_traversers (short tag , Size_Proc size , Mark_Proc mark , Fixup_Proc fixup , int is_constant_size , int is_atomic ) ; 
  extern void * GC_resolve (void * p ) ; 
  extern void GC_mark (const void * p ) ; 
  extern void GC_fixup (void * p ) ; 
  extern Scheme_Object * scheme_make_pair (Scheme_Object * car , Scheme_Object * cdr ) ; 
  extern Scheme_Object * scheme_make_utf8_string (const char * chars ) ; 
  extern Scheme_Object * scheme_make_locale_string (const char * chars ) ; 
  extern Scheme_Object * scheme_make_vector (int size , Scheme_Object * fill ) ; 
  extern int scheme_file_exists (char * filename ) ; 
  extern char * scheme_expand_filename (char * filename , int ilen , const char * errorin , int * ex , int guards ) ; 
  extern Scheme_Object * scheme_make_path (const char * chars ) ; 
  extern Scheme_Object * scheme_lookup_global (Scheme_Object * symbol , Scheme_Env * env ) ; 
  extern Scheme_Object * scheme_builtin_value (const char * name ) ; 
  extern Scheme_Object * scheme_dynamic_require (int argc , Scheme_Object * argv [] ) ; 
  extern Scheme_Object * scheme_datum_to_kernel_stx (Scheme_Object * e ) ; 
  extern Scheme_Object * scheme_intern_symbol (const char * name ) ; 
  extern Scheme_Object * scheme_vector_to_list (Scheme_Object * vec ) ; 
  extern Scheme_Object * scheme_load (const char * file ) ; 
}
extern "C" {
  void objscheme_init (Scheme_Env * ) ; 
  typedef struct Scheme_Class_Object {
    Scheme_Object so ; 
    void * __type ; 
    long primflag ; 
    void * primdata ; 
  }
  Scheme_Class_Object ; 
  typedef Scheme_Prim Scheme_Method_Prim ; 
  typedef long ExactLong ; 
  void objscheme_init (Scheme_Env * env ) ; 
  mzchar * objscheme_unbundle_mzstring (Scheme_Object * , const char * ) ; 
  mzchar * objscheme_unbundle_mzstring (Scheme_Object * , const char * ) ; 
  typedef Scheme_Object * (* Objscheme_Bundler ) (void * ) ; 
  typedef const char * cstring , * ncstring ; 
  typedef const char * cpstring , * ncpstring ; 
  typedef const char * cbstring , * ncbstring ; 
  typedef const mzchar * cmzstring , * ncmzstring ; 
}
; 
extern void mred_wait_eventspace (void ) ; 
extern Scheme_Object * wxSchemeFindDirectory (int argc , Scheme_Object * * argv ) ; 
extern int wxGetPreference (const char * name , int * res ) ; 
typedef XEvent MrEdEvent ; 
class wxTimer ; 
class MrEdContextFrames ; 
typedef Scheme_Object * MrEdContextFramesRef ; 
class MrEdContextFrames : public gc {
  public : wxChildList * list ; 
  MrEdContextFramesRef next , prev ; 
  inline void gcInit_MrEdContextFrames () {
  }
  public : inline void gcMark () {
    gc :: gcMark () ; 
    gcMARK_TYPED (MrEdContextFramesRef , next ) ; 
    gcMARK_TYPED (MrEdContextFramesRef , prev ) ; 
    gcMARK_TYPED (wxChildList * , list ) ; 
  }
  inline void gcFixup () {
    gc :: gcFixup () ; 
    gcFIXUP_TYPED (MrEdContextFramesRef , next ) ; 
    gcFIXUP_TYPED (MrEdContextFramesRef , prev ) ; 
    gcFIXUP_TYPED (wxChildList * , list ) ; 
  }
}
; 
class MrEdFinalizedContext ; 
class MrEd_Saved_Modal ; 
typedef int (* wxDispatch_Check_Fun ) (void * ) ; 
typedef void (* wxDispatch_Needs_Wakeup_Fun ) (void * , void * ) ; 
typedef struct MrEdContext {
  Scheme_Object so ; 
  Scheme_Thread * handler_running ; 
  int suspended ; 
  MrEdFinalizedContext * finalized ; 
  wxChildList * topLevelWindowList ; 
  wxStandardSnipClassList * snipClassList ; 
  wxBufferDataClassList * bufferDataClassList ; 
  wxWindow * modal_window ; 
  MrEd_Saved_Modal * modal_stack ; 
  Scheme_Config * main_config ; 
  Scheme_Thread_Cell_Table * main_cells ; 
  Scheme_Object * main_break_cell ; 
  short ready_to_go ; 
  short ready , waiting_for_nested , nested_avail ; 
  short q_callback ; 
  wxTimer * timer ; 
  MrEdEvent event ; 
  wxTimer * timers ; 
  wxDispatch_Check_Fun alternate ; 
  void * alt_data ; 
  struct MrEdContext * next ; 
  int busyState ; 
  int killed ; 
  struct Context_Custodian_Hop * mr_hop ; 
  Scheme_Custodian_Reference * mref ; 
}
MrEdContext ; 
class MrEdFinalizedContext : public gc {
  public : Widget toplevel ; 
  MrEdContextFrames * frames ; 
  inline void gcInit_MrEdFinalizedContext () {
  }
  public : inline void gcMark () {
    gc :: gcMark () ; 
    gcMARK_TYPED (MrEdContextFrames * , frames ) ; 
    gcMARK_TYPED (Widget , toplevel ) ; 
  }
  inline void gcFixup () {
    gc :: gcFixup () ; 
    gcFIXUP_TYPED (MrEdContextFrames * , frames ) ; 
    gcFIXUP_TYPED (Widget , toplevel ) ; 
  }
}
; 
extern "C" {
  typedef void (* SLEEP_PROC_PTR ) (float seconds , void * fds ) ; 
}
typedef void * (* ForEachFrameProc ) (wxObject * , void * ) ; 
extern void wxCreateApp (void ) ; 
extern void wxDoMainLoop () ; 
typedef int (* MrEd_Finish_Cmd_Line_Run_Proc ) (void ) ; 
typedef void (* MrEd_Run_From_Cmd_Line_Proc ) (int argc , char * * argv , Scheme_Env * (* mk_basic_env ) (void ) ) ; 
extern void mred_set_finish_cmd_line_run (MrEd_Finish_Cmd_Line_Run_Proc ) ; 
extern void mred_set_run_from_cmd_line (MrEd_Run_From_Cmd_Line_Proc ) ; 
static void yield_indefinitely () {
  void * dummy ; 
  mz_jmp_buf * volatile save , newbuf ; 
  Scheme_Thread * volatile p ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(save, 1), PUSH(dummy, 2)));
# define XfOrM3_COUNT (3)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  dummy = NULLED_OUT ; 
  save = NULLED_OUT ; 
  p = NULLED_OUT ; 
  p = FUNCCALL(SETUP_XfOrM3(_), scheme_get_current_thread () ); 
  save = (p -> error_buf ) ; 
  (p -> error_buf ) = & newbuf ; 
  if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#   define XfOrM4_COUNT (0+XfOrM3_COUNT)
#   define SETUP_XfOrM4(x) SETUP_XfOrM3(x)
    FUNCCALL(SETUP_XfOrM4(_), mred_wait_eventspace () ); 
  }
  (p -> error_buf ) = save ; 
  dummy = __null ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static char * get_init_filename (Scheme_Env * env ) {
  Scheme_Object * type ; 
  Scheme_Object * path ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(path, 0), PUSH(type, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  type = NULLED_OUT ; 
  path = NULLED_OUT ; 
  type = FUNCCALL(SETUP_XfOrM5(_), scheme_intern_symbol ("init-file" ) ); 
  path = FUNCCALL_AGAIN(wxSchemeFindDirectory (1 , & type ) ); 
  RET_VALUE_START ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
char * cmdline_exe_hack = "[Replace me for EXE hack                                       ]" ; 
char * binary_type_hack = "bINARy tYPe:" "ri" "3" ; 
static char * _coldir = "coLLECTs dIRECTORy:" "/builddir/build/BUILD/plt-4.1/collects" "\0\0" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" "****************************************************************" ; 
static int _coldir_offset = 19 ; 
static int is_number_arg (const char * s ) {
  /* No conversion */
  while (* s ) {
    if (* s < '0' || * s > '9' ) {
      if (* s == '.' ) {
        s ++ ; 
        while (* s ) {
          if (* s < '0' || * s > '9' )
            return 0 ; 
          else s ++ ; 
        }
        return 1 ; 
      }
      else return 0 ; 
    }
    else s ++ ; 
  }
  return 1 ; 
}
static char * make_embedded_load (const char * start , const char * end ) {
  char * s ; 
  int slen , elen ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(start, 0), PUSH(s, 1), PUSH(end, 2)));
# define XfOrM17_COUNT (3)
# define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  slen = strlen (start ) ; 
  elen = strlen (end ) ; 
  s = (char * ) FUNCCALL(SETUP_XfOrM17(_), malloc (slen + elen + 2 ) ); 
  (memcpy (s , start , slen + 1 ) ) ; 
  (memcpy (s + slen + 1 , end , elen + 1 ) ) ; 
  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
typedef struct {
  int init_ns ; 
  int num_enl ; 
  int no_init_file ; 
  int use_repl ; 
  int script_mode ; 
  int add_yield ; 
  int alternate_rep ; 
  int no_front ; 
}
FinishArgsAtoms ; 
typedef struct {
  FinishArgsAtoms * a ; 
  char * * evals_and_loads ; 
  int * eval_kind ; 
  Scheme_Object * main_args ; 
  Scheme_Env * global_env ; 
  char * init_lib ; 
}
FinishArgs ; 
typedef void (* Repl_Proc ) (Scheme_Env * ) ; 
static int finish_cmd_line_run (FinishArgs * fa , Repl_Proc repl ) {
  volatile int exit_val = 0 ; 
  Scheme_Object * __funcarg147 = NULLED_OUT ; 
  Scheme_Object * __funcarg146 = NULLED_OUT ; 
  Scheme_Object * __funcarg145 = NULLED_OUT ; 
  Scheme_Object * __funcarg144 = NULLED_OUT ; 
  Scheme_Object * __funcarg143 = NULLED_OUT ; 
  Scheme_Object * __funcarg142 = NULLED_OUT ; 
  Scheme_Object * __funcarg141 = NULLED_OUT ; 
  Scheme_Object * __funcarg140 = NULLED_OUT ; 
  Scheme_Object * __funcarg139 = NULLED_OUT ; 
  Scheme_Object * __funcarg138 = NULLED_OUT ; 
  Scheme_Object * __funcarg137 = NULLED_OUT ; 
  Scheme_Config * __funcarg136 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(17);
  BLOCK_SETUP_TOP((PUSH(__funcarg140, 0), PUSH(__funcarg142, 1), PUSH(__funcarg144, 2), PUSH(__funcarg146, 3), PUSH(fa, 4)));
# define XfOrM18_COUNT (5)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (fa -> a -> init_ns ) {
    Scheme_Object * nsreq , * a [1 ] ; 
    Scheme_Thread * volatile p ; 
    mz_jmp_buf * volatile save , newbuf ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM18_COUNT), PUSHARRAY(a, 1, 1+XfOrM18_COUNT), PUSH(save, 4+XfOrM18_COUNT), PUSH(nsreq, 5+XfOrM18_COUNT)));
#   define XfOrM73_COUNT (6+XfOrM18_COUNT)
#   define SETUP_XfOrM73(x) SETUP(XfOrM73_COUNT)
    nsreq = NULLED_OUT ; 
    a[0] = NULLED_OUT ; 
    p = NULLED_OUT ; 
    save = NULLED_OUT ; 
    nsreq = FUNCCALL(SETUP_XfOrM73(_), scheme_builtin_value ("namespace-require" ) ); 
    a [0 ] = (__funcarg144 = FUNCCALL(SETUP_XfOrM73(_), scheme_intern_symbol ("lib" ) ), __funcarg145 = (__funcarg146 = FUNCCALL(SETUP_XfOrM73(_), scheme_make_utf8_string (fa -> init_lib ) ), __funcarg147 = FUNCCALL(SETUP_XfOrM73(_), scheme_make_null () ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg146 , __funcarg147 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg144 , __funcarg145 ) )) ; 
    p = FUNCCALL(SETUP_XfOrM73(_), scheme_get_current_thread () ); 
    save = (p -> error_buf ) ; 
    (p -> error_buf ) = & newbuf ; 
    if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) )
      FUNCCALL(SETUP_XfOrM73(_), scheme_apply (nsreq , 1 , a ) ); 
    else {
      exit_val = 1 ; 
    }
    (p -> error_buf ) = save ; 
  }
  {
    volatile int i ; 
    mz_jmp_buf * volatile save , newbuf ; 
    BLOCK_SETUP((PUSH(save, 0+XfOrM18_COUNT)));
#   define XfOrM26_COUNT (1+XfOrM18_COUNT)
#   define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
    save = NULLED_OUT ; 
    for (i = 0 ; i < fa -> a -> num_enl ; i ++ ) {
#     define XfOrM50_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM50(x) SETUP_XfOrM26(x)
      if (fa -> eval_kind [i ] == 1 ) {
#       define XfOrM71_COUNT (0+XfOrM50_COUNT)
#       define SETUP_XfOrM71(x) SETUP_XfOrM50(x)
        if (! FUNCCALL(SETUP_XfOrM71(_), scheme_load (fa -> evals_and_loads [i ] ) )) {
          exit_val = 1 ; 
          break ; 
        }
      }
      else if ((fa -> eval_kind [i ] == 0 ) || (fa -> eval_kind [i ] == 3 ) || (fa -> eval_kind [i ] == 4 ) || (fa -> eval_kind [i ] == 5 ) || (fa -> eval_kind [i ] == 6 ) ) {
        Scheme_Thread * volatile p ; 
        BLOCK_SETUP((PUSH(p, 0+XfOrM50_COUNT)));
#       define XfOrM62_COUNT (1+XfOrM50_COUNT)
#       define SETUP_XfOrM62(x) SETUP(XfOrM62_COUNT)
        p = NULLED_OUT ; 
        p = FUNCCALL(SETUP_XfOrM62(_), scheme_get_current_thread () ); 
        save = (p -> error_buf ) ; 
        (p -> error_buf ) = & newbuf ; 
        if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#         define XfOrM64_COUNT (0+XfOrM62_COUNT)
#         define SETUP_XfOrM64(x) SETUP_XfOrM62(x)
          if (fa -> eval_kind [i ] == 0 ) {
#           define XfOrM70_COUNT (0+XfOrM64_COUNT)
#           define SETUP_XfOrM70(x) SETUP_XfOrM64(x)
            FUNCCALL(SETUP_XfOrM70(_), scheme_eval_string_all_with_prompt (fa -> evals_and_loads [i ] , fa -> global_env , 2 ) ); 
          }
          else if (fa -> eval_kind [i ] == 6 ) {
            Scheme_Object * s , * e , * a [3 ] , * eload ; 
            BLOCK_SETUP((PUSH(s, 0+XfOrM64_COUNT), PUSH(e, 1+XfOrM64_COUNT), PUSH(eload, 2+XfOrM64_COUNT), PUSHARRAY(a, 3, 3+XfOrM64_COUNT)));
#           define XfOrM69_COUNT (6+XfOrM64_COUNT)
#           define SETUP_XfOrM69(x) SETUP(XfOrM69_COUNT)
            s = NULLED_OUT ; 
            e = NULLED_OUT ; 
            a[0] = NULLED_OUT ; 
            a[1] = NULLED_OUT ; 
            a[2] = NULLED_OUT ; 
            eload = NULLED_OUT ; 
            eload = FUNCCALL(SETUP_XfOrM69(_), scheme_builtin_value ("embedded-load" ) ); 
            s = FUNCCALL_AGAIN(scheme_make_utf8_string (fa -> evals_and_loads [i ] ) ); 
            e = FUNCCALL_AGAIN(scheme_make_utf8_string (fa -> evals_and_loads [i ] + strlen (fa -> evals_and_loads [i ] ) + 1 ) ); 
            a [0 ] = s ; 
            a [1 ] = e ; 
            a [2 ] = FUNCCALL(SETUP_XfOrM69(_), scheme_make_false () ); 
            FUNCCALL(SETUP_XfOrM69(_), scheme_apply (eload , 3 , a ) ); 
          }
          else {
            Scheme_Object * a [1 ] , * nsreq ; 
            char * name ; 
            BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM64_COUNT), PUSH(name, 3+XfOrM64_COUNT), PUSH(nsreq, 4+XfOrM64_COUNT)));
#           define XfOrM65_COUNT (5+XfOrM64_COUNT)
#           define SETUP_XfOrM65(x) SETUP(XfOrM65_COUNT)
            a[0] = NULLED_OUT ; 
            nsreq = NULLED_OUT ; 
            name = NULLED_OUT ; 
            nsreq = FUNCCALL(SETUP_XfOrM65(_), scheme_builtin_value ("namespace-require" ) ); 
            if (fa -> eval_kind [i ] == 4 ) {
              name = "lib" ; 
            }
            else if (fa -> eval_kind [i ] == 5 ) {
              name = "planet" ; 
            }
            else {
              name = "file" ; 
            }
            a [0 ] = (__funcarg140 = FUNCCALL(SETUP_XfOrM65(_), scheme_intern_symbol (name ) ), __funcarg141 = (__funcarg142 = FUNCCALL(SETUP_XfOrM65(_), scheme_make_utf8_string (fa -> evals_and_loads [i ] ) ), __funcarg143 = FUNCCALL(SETUP_XfOrM65(_), scheme_make_null () ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg142 , __funcarg143 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg140 , __funcarg141 ) )) ; 
            FUNCCALL(SETUP_XfOrM65(_), scheme_apply (nsreq , 1 , a ) ); 
          }
        }
        else {
          exit_val = 1 ; 
          (p -> error_buf ) = save ; 
          break ; 
        }
        (p -> error_buf ) = save ; 
      }
      else if (fa -> eval_kind [i ] == 2 ) {
        Scheme_Thread * volatile p ; 
        BLOCK_SETUP((PUSH(p, 0+XfOrM50_COUNT)));
#       define XfOrM51_COUNT (1+XfOrM50_COUNT)
#       define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
        p = NULLED_OUT ; 
        p = FUNCCALL(SETUP_XfOrM51(_), scheme_get_current_thread () ); 
        save = (p -> error_buf ) ; 
        (p -> error_buf ) = & newbuf ; 
        if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
          Scheme_Object * e , * a [2 ] , * d2s , * nsi , * idb , * b , * cp ; 
          BLOCK_SETUP((PUSH(e, 0+XfOrM51_COUNT), PUSH(b, 1+XfOrM51_COUNT), PUSH(cp, 2+XfOrM51_COUNT), PUSH(idb, 3+XfOrM51_COUNT), PUSH(nsi, 4+XfOrM51_COUNT), PUSH(d2s, 5+XfOrM51_COUNT), PUSHARRAY(a, 2, 6+XfOrM51_COUNT)));
#         define XfOrM53_COUNT (9+XfOrM51_COUNT)
#         define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
          e = NULLED_OUT ; 
          a[0] = NULLED_OUT ; 
          a[1] = NULLED_OUT ; 
          d2s = NULLED_OUT ; 
          nsi = NULLED_OUT ; 
          idb = NULLED_OUT ; 
          b = NULLED_OUT ; 
          cp = NULLED_OUT ; 
          d2s = FUNCCALL(SETUP_XfOrM53(_), scheme_builtin_value ("datum->syntax" ) ); 
          a [0 ] = FUNCCALL(SETUP_XfOrM53(_), scheme_make_false () ); 
          e = FUNCCALL(SETUP_XfOrM53(_), scheme_intern_symbol ("main" ) ); 
          a [1 ] = e ; 
          e = FUNCCALL(SETUP_XfOrM53(_), scheme_apply (d2s , 2 , a ) ); 
          nsi = FUNCCALL_AGAIN(scheme_builtin_value ("namespace-syntax-introduce" ) ); 
          a [0 ] = e ; 
          e = FUNCCALL(SETUP_XfOrM53(_), scheme_apply (nsi , 1 , a ) ); 
          idb = FUNCCALL_AGAIN(scheme_builtin_value ("identifier-binding" ) ); 
          a [0 ] = e ; 
          b = FUNCCALL(SETUP_XfOrM53(_), scheme_apply (idb , 1 , a ) ); 
          if (b == FUNCCALL(SETUP_XfOrM53(_), scheme_make_false () )) {
#           define XfOrM60_COUNT (0+XfOrM53_COUNT)
#           define SETUP_XfOrM60(x) SETUP_XfOrM53(x)
            if (! (__funcarg139 = FUNCCALL(SETUP_XfOrM60(_), scheme_intern_symbol ("main" ) ), FUNCCALL_AGAIN(scheme_lookup_global (__funcarg139 , fa -> global_env ) )) ) {
#             define XfOrM61_COUNT (0+XfOrM60_COUNT)
#             define SETUP_XfOrM61(x) SETUP_XfOrM60(x)
              FUNCCALL(SETUP_XfOrM61(_), scheme_signal_error ("main: not defined or required into the top-level environment" ) ); 
            }
          }
          e = (__funcarg138 = FUNCCALL(SETUP_XfOrM53(_), scheme_vector_to_list (fa -> main_args ) ), FUNCCALL_AGAIN(scheme_make_pair (e , __funcarg138 ) )) ; 
          e = FUNCCALL(SETUP_XfOrM53(_), scheme_datum_to_kernel_stx (e ) ); 
          e = FUNCCALL_AGAIN(scheme_eval_multi_with_prompt (e , fa -> global_env ) ); 
          if (((e ) == (((Scheme_Object * ) 0x6 ) ) ) ) {
            Scheme_Object * * mv ; 
            int cnt ; 
            BLOCK_SETUP((PUSH(mv, 0+XfOrM53_COUNT)));
#           define XfOrM57_COUNT (1+XfOrM53_COUNT)
#           define SETUP_XfOrM57(x) SETUP(XfOrM57_COUNT)
            mv = NULLED_OUT ; 
            mv = (p -> ku ) . multiple . array ; 
            cnt = (p -> ku ) . multiple . count ; 
            FUNCCALL(SETUP_XfOrM57(_), scheme_detach_multple_array (mv ) ); 
            e = FUNCCALL_AGAIN(scheme_make_null () ); 
            while (cnt -- ) {
#             define XfOrM59_COUNT (0+XfOrM57_COUNT)
#             define SETUP_XfOrM59(x) SETUP_XfOrM57(x)
              e = FUNCCALL(SETUP_XfOrM59(_), scheme_make_pair (mv [cnt ] , e ) ); 
            }
          }
          else {
#           define XfOrM56_COUNT (0+XfOrM53_COUNT)
#           define SETUP_XfOrM56(x) SETUP_XfOrM53(x)
            e = (__funcarg137 = FUNCCALL(SETUP_XfOrM56(_), scheme_make_null () ), FUNCCALL_AGAIN(scheme_make_pair (e , __funcarg137 ) )) ; 
          }
          cp = (__funcarg136 = FUNCCALL(SETUP_XfOrM53(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg136 , MZCONFIG_PRINT_HANDLER ) )) ; 
          while (((Scheme_Type ) (((((long ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#           define XfOrM55_COUNT (0+XfOrM53_COUNT)
#           define SETUP_XfOrM55(x) SETUP_XfOrM53(x)
            a [0 ] = (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) ; 
            FUNCCALL(SETUP_XfOrM55(_), scheme_apply_multi (cp , 1 , a ) ); 
            e = (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ; 
          }
        }
        else {
          exit_val = 1 ; 
          (p -> error_buf ) = save ; 
          break ; 
        }
        (p -> error_buf ) = save ; 
      }
    }
  }
  if (fa -> a -> use_repl && ! fa -> a -> no_init_file ) {
    char * filename ; 
    BLOCK_SETUP((PUSH(filename, 0+XfOrM18_COUNT)));
#   define XfOrM24_COUNT (1+XfOrM18_COUNT)
#   define SETUP_XfOrM24(x) SETUP(XfOrM24_COUNT)
    filename = NULLED_OUT ; 
    filename = FUNCCALL(SETUP_XfOrM24(_), get_init_filename (fa -> global_env ) ); 
    if (filename ) {
#     define XfOrM25_COUNT (0+XfOrM24_COUNT)
#     define SETUP_XfOrM25(x) SETUP_XfOrM24(x)
      filename = FUNCCALL(SETUP_XfOrM25(_), scheme_expand_filename (filename , - 1 , "startup" , __null , 0x10 ) ); 
      if (FUNCCALL(SETUP_XfOrM25(_), scheme_file_exists (filename ) ))
        FUNCCALL(SETUP_XfOrM25(_), scheme_load (filename ) ); 
    }
  }
  if (fa -> a -> use_repl ) {
    mz_jmp_buf * volatile save , newbuf ; 
    Scheme_Thread * volatile p ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM18_COUNT), PUSH(save, 1+XfOrM18_COUNT)));
#   define XfOrM21_COUNT (2+XfOrM18_COUNT)
#   define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
    save = NULLED_OUT ; 
    p = NULLED_OUT ; 
    p = FUNCCALL(SETUP_XfOrM21(_), scheme_get_current_thread () ); 
    save = (p -> error_buf ) ; 
    (p -> error_buf ) = & newbuf ; 
    if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#     define XfOrM23_COUNT (0+XfOrM21_COUNT)
#     define SETUP_XfOrM23(x) SETUP_XfOrM21(x)
      FUNCCALL(SETUP_XfOrM23(_), repl (fa -> global_env ) ); 
      exit_val = 0 ; 
    }
    else {
      exit_val = 1 ; 
      ((fa -> a ) -> add_yield ) = 0 ; 
    }
    (p -> error_buf ) = save ; 
  }
  if (fa -> a -> add_yield ) {
    mz_jmp_buf * volatile save , newbuf ; 
    Scheme_Thread * volatile p ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM18_COUNT), PUSH(save, 1+XfOrM18_COUNT)));
#   define XfOrM19_COUNT (2+XfOrM18_COUNT)
#   define SETUP_XfOrM19(x) SETUP(XfOrM19_COUNT)
    save = NULLED_OUT ; 
    p = NULLED_OUT ; 
    p = FUNCCALL(SETUP_XfOrM19(_), scheme_get_current_thread () ); 
    save = (p -> error_buf ) ; 
    (p -> error_buf ) = & newbuf ; 
    if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#     define XfOrM20_COUNT (0+XfOrM19_COUNT)
#     define SETUP_XfOrM20(x) SETUP_XfOrM19(x)
      FUNCCALL(SETUP_XfOrM20(_), yield_indefinitely () ); 
    }
    (p -> error_buf ) = save ; 
  }
  RET_VALUE_START (exit_val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int get_log_level (char * prog , char * real_switch , const char * envvar , const char * what , char * str ) {
  /* No conversion */
  if (! strcmp (str , "none" ) )
    return 0 ; 
  else if (! strcmp (str , "fatal" ) )
    return 1 ; 
  else if (! strcmp (str , "error" ) )
    return 2 ; 
  else if (! strcmp (str , "warning" ) )
    return 3 ; 
  else if (! strcmp (str , "info" ) )
    return 4 ; 
  else if (! strcmp (str , "debug" ) )
    return 5 ; 
  printf ("%s: %s level %s%s%s must be one of the following:\n" "  none fatal error warning info or debug\n" " given: %s\n" , prog , what , real_switch ? "after " : "in " , real_switch ? real_switch : envvar , real_switch ? " switch" : " envrionment variable" , str ) ; 
  return - 1 ; 
}
static int get_arg_log_level (char * prog , char * real_switch , const char * what , int argc , char * * argv ) {
  /* No conversion */
  if (argc < 2 ) {
    printf ("%s: missing %s level after %s switch\n" , prog , what , real_switch ) ; 
    return - 1 ; 
  }
  return get_log_level (prog , real_switch , __null , what , argv [1 ] ) ; 
}
static int run_from_cmd_line (int argc , char * _argv [] , Scheme_Env * (* mk_basic_env ) (void ) , int (* cont_run ) (FinishArgs * f ) ) {
  GC_CAN_IGNORE char * * argv = _argv ; 
  Scheme_Env * global_env ; 
  char * prog , * sprog = __null ; 
  Scheme_Object * sch_argv , * collects_path = __null , * collects_extra = __null ; 
  int i ; 
  char * * evals_and_loads , * real_switch = __null , specific_switch [2 ] ; 
  int * eval_kind , num_enl ; 
  int no_more_switches = 0 ; 
  int show_vers = 0 ; 
  int use_repl = 0 ; 
  int script_mode = 0 ; 
  int no_init_file = 0 ; 
  int add_yield = 1 ; 
  int alternate_rep = 0 ; 
  int no_front = 0 ; 
  char * init_lib = "scheme/gui/init" ; 
  int was_config_flag = 0 , saw_nc_flag = 0 ; 
  int no_compiled = 0 ; 
  int init_ns = 0 , no_init_ns = 0 ; 
  int syslog_level = - 1 , stderr_level = - 1 ; 
  FinishArgs * fa ; 
  FinishArgsAtoms * fa_a ; 
  Scheme_Object * __funcarg156 = NULLED_OUT ; 
  Scheme_Config * __funcarg152 = NULLED_OUT ; 
  Scheme_Object * __funcarg151 = NULLED_OUT ; 
  Scheme_Config * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(init_lib, 0), PUSH(fa_a, 1), PUSH(sprog, 2), PUSH(__funcarg150, 3), PUSH(fa, 4), PUSH(collects_extra, 5), PUSH(collects_path, 6), PUSH(sch_argv, 7), PUSH(global_env, 8), PUSH(eval_kind, 9), PUSH(evals_and_loads, 10), PUSH(_argv, 11), PUSH(real_switch, 12), PUSH(prog, 13)));
# define XfOrM78_COUNT (14)
# define SETUP_XfOrM78(x) SETUP(XfOrM78_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  global_env = NULLED_OUT ; 
  prog = NULLED_OUT ; 
  sch_argv = NULLED_OUT ; 
  evals_and_loads = NULLED_OUT ; 
  eval_kind = NULLED_OUT ; 
  fa = NULLED_OUT ; 
  fa_a = NULLED_OUT ; 
  prog = argv [0 ] ; 
  argv ++ ; 
  -- argc ; 
  if (cmdline_exe_hack [0 ] != '[' ) {
    int n , i ; 
    long d ; 
    GC_CAN_IGNORE unsigned char * p ; 
    GC_CAN_IGNORE unsigned char * orig_p ; 
    char * * argv2 ; 
    BLOCK_SETUP((PUSH(argv2, 0+XfOrM78_COUNT)));
#   define XfOrM154_COUNT (1+XfOrM78_COUNT)
#   define SETUP_XfOrM154(x) SETUP(XfOrM154_COUNT)
    argv2 = NULLED_OUT ; 
    p = (unsigned char * ) cmdline_exe_hack + 1 ; 
    orig_p = p ; 
    n = 0 ; 
    while (p [0 ] || p [1 ] || p [2 ] || p [3 ] ) {
      n ++ ; 
      p += (p [0 ] + (((long ) p [1 ] ) << 8 ) + (((long ) p [2 ] ) << 16 ) + (((long ) p [3 ] ) << 24 ) + 4 ) ; 
    }
    argv2 = (char * * ) FUNCCALL(SETUP_XfOrM154(_), malloc (sizeof (char * ) * (argc + n ) ) ); 
    p = orig_p ; 
    for (i = 0 ; i < n ; i ++ ) {
      d = (p [0 ] + (((long ) p [1 ] ) << 8 ) + (((long ) p [2 ] ) << 16 ) + (((long ) p [3 ] ) << 24 ) ) ; 
      argv2 [i ] = (char * ) p + 4 ; 
      p += d + 4 ; 
    }
    for (; i < n + argc ; i ++ ) {
      argv2 [i ] = argv [i - n ] ; 
    }
    argv = argv2 ; 
    argc += n ; 
  }
  evals_and_loads = (char * * ) FUNCCALL(SETUP_XfOrM78(_), malloc (sizeof (char * ) * argc ) ); 
  eval_kind = (int * ) FUNCCALL(SETUP_XfOrM78(_), malloc (sizeof (int ) * argc ) ); 
  num_enl = 0 ; 
  while (! no_more_switches && argc && argv [0 ] [0 ] == '-' && ! FUNCCALL(SETUP_XfOrM78(_), is_number_arg (argv [0 ] + 1 ) )) {
#   define XfOrM127_COUNT (0+XfOrM78_COUNT)
#   define SETUP_XfOrM127(x) SETUP_XfOrM78(x)
    real_switch = argv [0 ] ; 
    if (! (strcmp ("--help" , argv [0 ] ) ) )
      argv [0 ] = "-h" ; 
    else if (! (strcmp ("--eval" , argv [0 ] ) ) )
      argv [0 ] = "-e" ; 
    else if (! (strcmp ("--load" , argv [0 ] ) ) )
      argv [0 ] = "-f" ; 
    else if (! (strcmp ("--require" , argv [0 ] ) ) )
      argv [0 ] = "-t" ; 
    else if (! (strcmp ("--lib" , argv [0 ] ) ) )
      argv [0 ] = "-l" ; 
    else if (! (strcmp ("--script" , argv [0 ] ) ) )
      argv [0 ] = "-r" ; 
    else if (! (strcmp ("--require-script" , argv [0 ] ) ) )
      argv [0 ] = "-u" ; 
    else if (! (strcmp ("--main" , argv [0 ] ) ) )
      argv [0 ] = "-m" ; 
    else if (! (strcmp ("--name" , argv [0 ] ) ) )
      argv [0 ] = "-N" ; 
    else if (! (strcmp ("--no-compiled" , argv [0 ] ) ) )
      argv [0 ] = "-c" ; 
    else if (! (strcmp ("--no-lib" , argv [0 ] ) ) )
      argv [0 ] = "-n" ; 
    else if (! (strcmp ("--version" , argv [0 ] ) ) )
      argv [0 ] = "-v" ; 
    else if (! (strcmp ("--no-init-file" , argv [0 ] ) ) )
      argv [0 ] = "-q" ; 
    else if (! (strcmp ("--no-jit" , argv [0 ] ) ) )
      argv [0 ] = "-j" ; 
    else if (! (strcmp ("--no-delay" , argv [0 ] ) ) )
      argv [0 ] = "-d" ; 
    else if (! (strcmp ("--no-argv" , argv [0 ] ) ) )
      argv [0 ] = "-A" ; 
    else if (! (strcmp ("--repl" , argv [0 ] ) ) )
      argv [0 ] = "-i" ; 
    else if (! (strcmp ("--binary" , argv [0 ] ) ) )
      argv [0 ] = "-b" ; 
    else if (! (strcmp ("--warn" , argv [0 ] ) ) )
      argv [0 ] = "-W" ; 
    else if (! (strcmp ("--syslog" , argv [0 ] ) ) )
      argv [0 ] = "-L" ; 
    else if (! (strcmp ("--collects" , argv [0 ] ) ) )
      argv [0 ] = "-X" ; 
    else if (! (strcmp ("--search" , argv [0 ] ) ) )
      argv [0 ] = "-S" ; 
    else if (! (strcmp ("--stdio" , argv [0 ] ) ) )
      argv [0 ] = "-z" ; 
    else if (! (strcmp ("--back" , argv [0 ] ) ) )
      argv [0 ] = "-G" ; 
    else if (! (strcmp ("--no-yield" , argv [0 ] ) ) )
      argv [0 ] = "-V" ; 
    if (! argv [0 ] [1 ] || (argv [0 ] [1 ] == '-' && argv [0 ] [2 ] ) ) {
      specific_switch [0 ] = 0 ; 
      goto bad_switch ; 
    }
    else {
      GC_CAN_IGNORE char * str ; 
      char * se ; 
      BLOCK_SETUP((PUSH(se, 0+XfOrM127_COUNT)));
#     define XfOrM128_COUNT (1+XfOrM127_COUNT)
#     define SETUP_XfOrM128(x) SETUP(XfOrM128_COUNT)
      se = NULLED_OUT ; 
      for (str = argv [0 ] + 1 ; * str ; str ++ ) {
#       define XfOrM141_COUNT (0+XfOrM128_COUNT)
#       define SETUP_XfOrM141(x) SETUP_XfOrM128(x)
        switch (* str ) {
#         define XfOrM142_COUNT (0+XfOrM141_COUNT)
#         define SETUP_XfOrM142(x) SETUP_XfOrM141(x)
          case 'h' : goto show_help ; 
          break ; 
          case 'e' : if (argc < 2 ) {
#           define XfOrM152_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM152(x) SETUP_XfOrM142(x)
            (printf ("%s: missing expression after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          evals_and_loads [num_enl ] = argv [0 ] ; 
          eval_kind [num_enl ++ ] = 0 ; 
          init_ns = 1 ; 
          break ; 
          case 'X' : if (argc < 2 ) {
#           define XfOrM151_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM151(x) SETUP_XfOrM142(x)
            (printf ("%s: missing path after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          collects_path = FUNCCALL(SETUP_XfOrM142(_), scheme_make_path (argv [0 ] ) ); 
          was_config_flag = 1 ; 
          break ; 
          case 'U' : FUNCCALL(SETUP_XfOrM142(_), scheme_set_ignore_user_paths (1 ) ); 
          was_config_flag = 1 ; 
          break ; 
          case 'I' : if (argc < 2 ) {
#           define XfOrM150_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM150(x) SETUP_XfOrM142(x)
            (printf ("%s: missing path after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          init_lib = argv [0 ] ; 
          was_config_flag = 1 ; 
          break ; 
          case 'S' : if (argc < 2 ) {
#           define XfOrM149_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM149(x) SETUP_XfOrM142(x)
            (printf ("%s: missing path after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          if (! collects_extra )
            collects_extra = FUNCCALL(SETUP_XfOrM142(_), scheme_make_null () ); 
          collects_extra = (__funcarg156 = FUNCCALL(SETUP_XfOrM142(_), scheme_make_path (argv [0 ] ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg156 , collects_extra ) )) ; 
          was_config_flag = 1 ; 
          break ; 
          case 'c' : no_compiled = 1 ; 
          was_config_flag = 1 ; 
          break ; 
          case 'm' : evals_and_loads [num_enl ] = "" ; 
          eval_kind [num_enl ++ ] = 2 ; 
          init_ns = 1 ; 
          break ; 
          case 'r' : script_mode = 1 ; 
          no_more_switches = 1 ; 
          if (argc > 1 )
            sprog = argv [1 ] ; 
          case 'f' : if (argc < 2 ) {
#           define XfOrM148_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM148(x) SETUP_XfOrM142(x)
            (printf ("%s: missing file name after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          evals_and_loads [num_enl ] = argv [0 ] ; 
          eval_kind [num_enl ++ ] = 1 ; 
          init_ns = 1 ; 
          break ; 
          case 'u' : script_mode = 1 ; 
          no_more_switches = 1 ; 
          if (argc > 1 )
            sprog = argv [1 ] ; 
          case 't' : if (argc < 2 ) {
#           define XfOrM147_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM147(x) SETUP_XfOrM142(x)
            (printf ("%s: missing file name after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          evals_and_loads [num_enl ] = argv [0 ] ; 
          eval_kind [num_enl ++ ] = 3 ; 
          if (! init_ns )
            no_init_ns = 1 ; 
          break ; 
          case 'l' : if (argc < 2 ) {
#           define XfOrM146_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM146(x) SETUP_XfOrM142(x)
            (printf ("%s: missing library name after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          evals_and_loads [num_enl ] = argv [0 ] ; 
          eval_kind [num_enl ++ ] = 4 ; 
          if (! init_ns )
            no_init_ns = 1 ; 
          break ; 
          case 'p' : if (argc < 2 ) {
#           define XfOrM145_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM145(x) SETUP_XfOrM142(x)
            (printf ("%s: missing package name after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          evals_and_loads [num_enl ] = argv [0 ] ; 
          eval_kind [num_enl ++ ] = 5 ; 
          if (! init_ns )
            no_init_ns = 1 ; 
          break ; 
          case 'k' : if (argc < 3 ) {
#           define XfOrM144_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM144(x) SETUP_XfOrM142(x)
            (printf ("%s: missing %s after %s switch\n" , prog , (argc < 2 ) ? "starting and ending offsets" : "ending offset" , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          se = FUNCCALL(SETUP_XfOrM142(_), make_embedded_load (argv [0 ] , argv [1 ] ) ); 
          evals_and_loads [num_enl ] = se ; 
          argv ++ ; 
          -- argc ; 
          eval_kind [num_enl ++ ] = 6 ; 
          break ; 
          case 'N' : if (argc < 2 ) {
#           define XfOrM143_COUNT (0+XfOrM142_COUNT)
#           define SETUP_XfOrM143(x) SETUP_XfOrM142(x)
            (printf ("%s: missing name after %s switch\n" , prog , real_switch ) ) ; 
            goto show_need_help ; 
          }
          argv ++ ; 
          -- argc ; 
          sprog = argv [0 ] ; 
          was_config_flag = 1 ; 
          break ; 
          case 'q' : no_init_file = 1 ; 
          was_config_flag = 1 ; 
          break ; 
          case 'n' : no_init_ns = 1 ; 
          break ; 
          case 'v' : show_vers = 1 ; 
          break ; 
          case 'V' : show_vers = 1 ; 
          add_yield = 0 ; 
          break ; 
          case 'i' : use_repl = 1 ; 
          init_ns = 1 ; 
          break ; 
          case '-' : no_more_switches = 1 ; 
          was_config_flag = 1 ; 
          break ; 
          case 'j' : FUNCCALL(SETUP_XfOrM142(_), scheme_set_startup_use_jit (0 ) ); 
          was_config_flag = 1 ; 
          break ; 
          case 'd' : FUNCCALL(SETUP_XfOrM142(_), scheme_set_startup_load_on_demand (0 ) ); 
          was_config_flag = 1 ; 
          break ; 
          case 'b' : FUNCCALL(SETUP_XfOrM142(_), scheme_set_binary_mode_stdio (1 ) ); 
          was_config_flag = 1 ; 
          break ; 
          case 'z' : alternate_rep = 1 ; 
          no_front = 1 ; 
          use_repl = 1 ; 
          init_ns = 1 ; 
          break ; 
          case 'K' : no_front = 1 ; 
          break ; 
          case 'W' : stderr_level = FUNCCALL(SETUP_XfOrM142(_), get_arg_log_level (prog , real_switch , "stderr" , argc , argv ) ); 
          if (stderr_level < 0 )
            goto show_need_help ; 
          -- argc ; 
          argv ++ ; 
          was_config_flag = 1 ; 
          break ; 
          case 'L' : syslog_level = FUNCCALL(SETUP_XfOrM142(_), get_arg_log_level (prog , real_switch , "syslog" , argc , argv ) ); 
          if (syslog_level < 0 )
            goto show_need_help ; 
          -- argc ; 
          argv ++ ; 
          was_config_flag = 1 ; 
          break ; 
          default : specific_switch [0 ] = * str ; 
          specific_switch [1 ] = 0 ; 
          goto bad_switch ; 
        }
        if (was_config_flag )
          was_config_flag = 0 ; 
        else saw_nc_flag = 1 ; 
      }
      argv ++ ; 
      -- argc ; 
    }
  }
  if (! saw_nc_flag ) {
    if (! argc ) {
      use_repl = 1 ; 
      init_ns = 1 ; 
    }
    else if (argv [0 ] [0 ] != '-' ) {
      script_mode = 1 ; 
      no_more_switches = 1 ; 
      sprog = argv [0 ] ; 
      evals_and_loads [num_enl ] = argv [0 ] ; 
      eval_kind [num_enl ++ ] = 3 ; 
      argv ++ ; 
      -- argc ; 
    }
  }
  if (use_repl ) {
    show_vers = 1 ; 
  }
  if (no_init_ns )
    init_ns = 0 ; 
  if (show_vers ) {
#   define XfOrM95_COUNT (0+XfOrM78_COUNT)
#   define SETUP_XfOrM95(x) SETUP_XfOrM78(x)
    if (! use_repl || alternate_rep )
      (printf ("MrEd v" "4.1" " [3m]" ", Copyright (c) 2004-2008 PLT Scheme Inc.\n" ) ) ; 
    FUNCCALL(SETUP_XfOrM95(_), fflush (stdout ) ); 
  }
  if (syslog_level < 0 ) {
    char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM78_COUNT)));
#   define XfOrM93_COUNT (1+XfOrM78_COUNT)
#   define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)
    s = NULLED_OUT ; 
    s = FUNCCALL(SETUP_XfOrM93(_), getenv ("PLTSYSLOG" ) ); 
    if (s ) {
#     define XfOrM94_COUNT (0+XfOrM93_COUNT)
#     define SETUP_XfOrM94(x) SETUP_XfOrM93(x)
      syslog_level = FUNCCALL(SETUP_XfOrM94(_), get_log_level (prog , __null , "PLTSYSLOG" , "syslog" , s ) ); 
    }
  }
  if (stderr_level < 0 ) {
    char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM78_COUNT)));
#   define XfOrM91_COUNT (1+XfOrM78_COUNT)
#   define SETUP_XfOrM91(x) SETUP(XfOrM91_COUNT)
    s = NULLED_OUT ; 
    s = FUNCCALL(SETUP_XfOrM91(_), getenv ("PLTSTDERR" ) ); 
    if (s ) {
#     define XfOrM92_COUNT (0+XfOrM91_COUNT)
#     define SETUP_XfOrM92(x) SETUP_XfOrM91(x)
      stderr_level = FUNCCALL(SETUP_XfOrM92(_), get_log_level (prog , __null , "PLTSTDERR" , "stderr" , s ) ); 
    }
  }
  FUNCCALL(SETUP_XfOrM78(_), scheme_set_logging (syslog_level , stderr_level ) ); 
  global_env = FUNCCALL(SETUP_XfOrM78(_), mk_basic_env () ); 
  sch_argv = FUNCCALL_AGAIN(scheme_make_vector (argc , __null ) ); 
  for (i = 0 ; i < argc ; i ++ ) {
    Scheme_Object * so ; 
    BLOCK_SETUP((PUSH(so, 0+XfOrM78_COUNT)));
#   define XfOrM90_COUNT (1+XfOrM78_COUNT)
#   define SETUP_XfOrM90(x) SETUP(XfOrM90_COUNT)
    so = NULLED_OUT ; 
    so = FUNCCALL(SETUP_XfOrM90(_), scheme_make_locale_string (argv [i ] ) ); 
    ((((Scheme_Inclhash_Object * ) (so ) ) -> so . keyex |= 0x1 ) ) ; 
    (((Scheme_Vector * ) (sch_argv ) ) -> els ) [i ] = so ; 
  }
  if (argc )
    ((((Scheme_Inclhash_Object * ) (sch_argv ) ) -> so . keyex |= 0x1 ) ) ; 
  (__funcarg152 = FUNCCALL(SETUP_XfOrM78(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_set_param (__funcarg152 , MZCONFIG_CMDLINE_ARGS , sch_argv ) )) ; 
  if (no_compiled )
    (__funcarg150 = FUNCCALL(SETUP_XfOrM78(_), scheme_current_config () ), __funcarg151 = FUNCCALL(SETUP_XfOrM78(_), scheme_make_null () ), FUNCCALL_AGAIN(scheme_set_param (__funcarg150 , MZCONFIG_USE_COMPILED_KIND , __funcarg151 ) )) ; 
  {
    Scheme_Object * ps ; 
    BLOCK_SETUP((PUSH(ps, 0+XfOrM78_COUNT)));
#   define XfOrM88_COUNT (1+XfOrM78_COUNT)
#   define SETUP_XfOrM88(x) SETUP(XfOrM88_COUNT)
    ps = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM88(_), scheme_set_exec_cmd (prog ) ); 
    if (! sprog )
      sprog = prog ; 
    ps = FUNCCALL(SETUP_XfOrM88(_), scheme_set_run_cmd (sprog ) ); 
  }
  {
    Scheme_Object * l , * r ; 
    int len , offset ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM78_COUNT), PUSH(l, 1+XfOrM78_COUNT)));
#   define XfOrM81_COUNT (2+XfOrM78_COUNT)
#   define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
    l = NULLED_OUT ; 
    r = NULLED_OUT ; 
    if (! collects_path )
      collects_path = FUNCCALL(SETUP_XfOrM81(_), scheme_make_path (_coldir XFORM_OK_PLUS _coldir_offset ) ); 
    FUNCCALL(SETUP_XfOrM81(_), scheme_set_collects_path (collects_path ) ); 
    if (collects_extra ) {
      l = collects_extra ; 
    }
    else {
#     define XfOrM84_COUNT (0+XfOrM81_COUNT)
#     define SETUP_XfOrM84(x) SETUP_XfOrM81(x)
      l = FUNCCALL(SETUP_XfOrM84(_), scheme_make_null () ); 
      offset = _coldir_offset ; 
      while (1 ) {
#       define XfOrM86_COUNT (0+XfOrM84_COUNT)
#       define SETUP_XfOrM86(x) SETUP_XfOrM84(x)
        len = strlen (_coldir XFORM_OK_PLUS offset ) ; 
        offset += len + 1 ; 
        if (! _coldir [offset ] )
          break ; 
        l = (__funcarg149 = FUNCCALL(SETUP_XfOrM86(_), scheme_make_path (_coldir XFORM_OK_PLUS offset ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg149 , l ) )) ; 
      }
    }
    r = FUNCCALL(SETUP_XfOrM81(_), scheme_make_null () ); 
    while (((Scheme_Type ) (((((long ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM83_COUNT (0+XfOrM81_COUNT)
#     define SETUP_XfOrM83(x) SETUP_XfOrM81(x)
      r = FUNCCALL(SETUP_XfOrM83(_), scheme_make_pair ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , r ) ); 
      l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
    }
    FUNCCALL(SETUP_XfOrM81(_), scheme_init_collection_paths (global_env , r ) ); 
  }
  fa_a = (FinishArgsAtoms * ) FUNCCALL(SETUP_XfOrM78(_), GC_malloc_atomic (sizeof (FinishArgsAtoms ) ) ); 
  fa = (FinishArgs * ) FUNCCALL(SETUP_XfOrM78(_), GC_malloc (sizeof (FinishArgs ) ) ); 
  (fa -> a ) = fa_a ; 
  ((fa -> a ) -> init_ns ) = init_ns ; 
  (fa -> evals_and_loads ) = evals_and_loads ; 
  (fa -> eval_kind ) = eval_kind ; 
  ((fa -> a ) -> num_enl ) = num_enl ; 
  (fa -> main_args ) = sch_argv ; 
  ((fa -> a ) -> no_init_file ) = no_init_file ; 
  ((fa -> a ) -> use_repl ) = use_repl ; 
  ((fa -> a ) -> script_mode ) = script_mode ; 
  ((fa -> a ) -> add_yield ) = add_yield ; 
  ((fa -> a ) -> alternate_rep ) = alternate_rep ; 
  ((fa -> a ) -> no_front ) = no_front ; 
  (fa -> init_lib ) = init_lib ; 
  (fa -> global_env ) = global_env ; 
  FUNCCALL(SETUP_XfOrM78(_), scheme_set_can_break (1 ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(cont_run (fa ) )) RET_VALUE_EMPTY_END ; 
  show_help : prog = ("%s" "mred" " [<option> ...] <argument> ...\n" " X configuration options (must precede all other options):\n" "  -display <display>, -geometry <geometry>, -fn <font>, -font <font>,\n" "  -bg <color>, -background <color>, -fg <color>, -foreground <color>,\n" "  -iconic, -name <name>, -rv, -reverse, +rv, -selectionTimeout <timeout>,\n" "  -synchronous, -title <title>, -xnllanguage <language>, -xrm <file>\n" " File and expression options:\n" "  -e <exprs>, --eval <exprs> : Evaluate <exprs>, prints results\n" "  -f <file>, --load <file> : Like -e '(load \"<file>\")' without printing\n" "  -t <file>, --require <file> : Like -e '(require (file \"<file>\"))'\n" "  -l <path>, --lib <path> : Like -e '(require (lib \"<path>\"))'\n" "  -p <package> : Like -e '(require (planet \"<package>\")'\n" "  -r <file>, --script <file> : Same as -f <file> -N <file> --\n" "  -u <file>, --require-script <file> : Same as -t <file> -N <file> --\n" "  -k <n> <m> : Load executable-embedded code from file offset <n> to <m>\n" "  -m, --main : Call `main' with command-line arguments, print results\n" " Interaction options:\n" "  -i, --repl : Run interactive read-eval-print loop; implies -v\n" "  -z, --text-repl : Like -i, but use text read-eval-print loop\n" "  -n, --no-lib : Skip `(require (lib \"<init-lib>\"))' for " "-i/-z" "/-e/-f/-r\n" "  -v, --version : Show version\n" "  -K, --back : Don't bring application to the foreground (Mac OS X)\n" "  -V, --no-yield : Don't `(yield 'wait)'\n" " Configuration options:\n" "  -c, --no-compiled : Disable loading of compiled files\n" "  -q, --no-init-file : Skip load of " "~/.mredrc" " for " "-i/-z" "\n" "  -I <path> : Set <init-lib> to <path>\n" "  -X <dir>, --collects <dir> : Main collects at <dir> relative to " "MrEd" "\n" "  -S <dir>, --search <dir> : More collects at <dir> relative to " "MrEd" "\n" "  -U, --no-user-path : Ignore user-specific collects, etc.\n" "  -N <file>, --name <file> : Sets `(find-system-path 'run-file)' to <file>\n" "  -j, --no-jit : Disable the just-in-time compiler\n" "  -d, --no-delay: Disable on-demand loading of syntax and code\n" "  -b, --binary : Read stdin and write stdout/stderr in binary mode\n" "  -W <level>, --warn <level> : Set stderr logging to <level>\n" "  -L <level>, --syslog <level> : Set syslog logging to <level>\n" " Meta options:\n" "  -- : No argument following this switch is used as a switch\n" "  -h, --help : Show this information and exits, ignoring other options\n" "Default options:\n" " If only configuration options are provided, -i is added\n" " If only configuration options are before the first argument, -u is added\n" " If -t/-l/-p/-u apears before the first -i/-e/-f/-r, -n is added\n" " <init-lib> defaults to " "scheme/gui/init" "\n" "Switch syntax:\n" " Multiple single-letter switches can be collapsed, with arguments placed\n" "   after the collapsed switches; the first collapsed switch cannot be --\n" " Example: `-ifve file expr' is the same as `-i -f file -v -e expr'\n" "Start-up sequence:\n" " 1. Set `current-library-collection-paths'\n" " 2. Require `(lib \"<init-lib>\")' [when " "-i/-z" "/-e/-f/-r, unless -n]\n" " 3. Evaluate/load expressions/files in order, until first error\n" " 4. Load \"" "~/.mredrc" "\" [when " "-i/-z" "]\n" " 5. Run read-eval-print loop [when " "-i/-z" "]\n" " 6. Run `(yield 'wait)' [unless -V]\n" ) ; 
  (printf (prog , "MrEd v" "4.1" " [3m]" ", Copyright (c) 2004-2008 PLT Scheme Inc.\n" ) ) ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
  bad_switch : if (specific_switch [0 ] && real_switch [2 ] ) {
#   define XfOrM80_COUNT (0+XfOrM78_COUNT)
#   define SETUP_XfOrM80(x) SETUP_XfOrM78(x)
    (printf ("%s: bad switch: -%s within: %s\n" , prog , specific_switch , real_switch ) ) ; 
  }
  else {
#   define XfOrM79_COUNT (0+XfOrM78_COUNT)
#   define SETUP_XfOrM79(x) SETUP_XfOrM78(x)
    (printf ("%s: bad switch: %s\n" , prog , real_switch ) ) ; 
  }
  show_need_help : (printf ("Use the --help or -h flag for help.\n" ) ) ; 
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static FinishArgs * xfa ; 
static void do_graph_repl (Scheme_Env * env ) {
  mz_jmp_buf * volatile save , newbuf ; 
  Scheme_Thread * volatile p ; 
  Scheme_Object * a [2 ] , * v ; 
  PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSHARRAY(a, 2, 1), PUSH(v, 4), PUSH(save, 5), PUSH(env, 6)));
# define XfOrM161_COUNT (7)
# define SETUP_XfOrM161(x) SETUP(XfOrM161_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  save = NULLED_OUT ; 
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  v = NULLED_OUT ; 
  p = FUNCCALL(SETUP_XfOrM161(_), scheme_get_current_thread () ); 
  save = (p -> error_buf ) ; 
  (p -> error_buf ) = & newbuf ; 
  if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#   define XfOrM162_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM162(x) SETUP_XfOrM161(x)
    if (xfa -> a -> alternate_rep ) {
#     define XfOrM164_COUNT (0+XfOrM162_COUNT)
#     define SETUP_XfOrM164(x) SETUP_XfOrM162(x)
      a [0 ] = FUNCCALL(SETUP_XfOrM164(_), scheme_intern_symbol ("mred/mred" ) ); 
      a [1 ] = FUNCCALL(SETUP_XfOrM164(_), scheme_intern_symbol ("textual-read-eval-print-loop" ) ); 
    }
    else {
#     define XfOrM163_COUNT (0+XfOrM162_COUNT)
#     define SETUP_XfOrM163(x) SETUP_XfOrM162(x)
      a [0 ] = FUNCCALL(SETUP_XfOrM163(_), scheme_intern_symbol ("mred/mred" ) ); 
      a [1 ] = FUNCCALL(SETUP_XfOrM163(_), scheme_intern_symbol ("graphical-read-eval-print-loop" ) ); 
    }
    v = FUNCCALL(SETUP_XfOrM162(_), scheme_dynamic_require (2 , a ) ); 
    FUNCCALL(SETUP_XfOrM162(_), scheme_apply (v , 0 , __null ) ); 
  }
  (p -> error_buf ) = save ; 
  env = __null ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int finish_cmd_line_run (void ) {
  /* No conversion */
  return finish_cmd_line_run (xfa , do_graph_repl ) ; 
}
static int do_main_loop (FinishArgs * fa ) {
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(fa, 0)));
# define XfOrM166_COUNT (1)
# define SETUP_XfOrM166(x) SETUP(XfOrM166_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  FUNCCALL(SETUP_XfOrM166(_), scheme_register_static ((void * ) & xfa , sizeof (xfa ) ) ); 
  xfa = fa ; 
  {
    mz_jmp_buf * volatile save , newbuf ; 
    Scheme_Thread * volatile p ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM166_COUNT), PUSH(save, 1+XfOrM166_COUNT)));
#   define XfOrM167_COUNT (2+XfOrM166_COUNT)
#   define SETUP_XfOrM167(x) SETUP(XfOrM167_COUNT)
    save = NULLED_OUT ; 
    p = NULLED_OUT ; 
    p = FUNCCALL(SETUP_XfOrM167(_), scheme_get_current_thread () ); 
    save = (p -> error_buf ) ; 
    (p -> error_buf ) = & newbuf ; 
    if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) )
      FUNCCALL(SETUP_XfOrM167(_), wxDoMainLoop () ); 
    (p -> error_buf ) = save ; 
  }
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void run_from_cmd_line (int argc , char * * argv , Scheme_Env * (* mk_basic_env ) (void ) ) {
  /* No conversion */
  run_from_cmd_line (argc , argv , mk_basic_env , do_main_loop ) ; 
}
static int main_after_stack (int argc , char * argv [] ) {
  int rval ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM169_COUNT (1)
# define SETUP_XfOrM169(x) SETUP(XfOrM169_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM169(_), mred_set_run_from_cmd_line (run_from_cmd_line ) ); 
  FUNCCALL(SETUP_XfOrM169(_), mred_set_finish_cmd_line_run (finish_cmd_line_run ) ); 
  FUNCCALL_AGAIN(wxCreateApp () ); 
  rval = FUNCCALL_EMPTY(wxEntry (argc , argv ) ); 
  RET_VALUE_START (rval ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
typedef struct {
  int argc ; 
  char * * argv ; 
}
Main_Args ; 
static int call_main_after_stack (void * data ) {
  /* No conversion */
  Main_Args * ma = (Main_Args * ) data ; 
  return main_after_stack (ma -> argc , ma -> argv ) ; 
}
int main (int argc , char * argv [] ) {
  Main_Args ma ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ma.argv, 0)));
# define XfOrM171_COUNT (1)
# define SETUP_XfOrM171(x) SETUP(XfOrM171_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ma.argv = NULLED_OUT ; 
  ma . argc = argc ; 
  ma . argv = argv ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM171(_), scheme_main_stack_setup (1 , call_main_after_stack , & ma ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
