#include "precomp.h"
extern double exp (double __x ) __attribute__ ((__nothrow__ ) ) ; 
extern int isnan (double __value ) __attribute__ ((__nothrow__ ) ) __attribute__ ((__const__ ) ) ; 
typedef enum {
  _IEEE_ = - 1 , _SVID_ , _XOPEN_ , _POSIX_ , _ISOC_ }
_LIB_VERSION_TYPE ; 
struct exception {
  int type ; 
  char * name ; 
  double arg1 ; 
  double arg2 ; 
  double retval ; 
}
; 
Scheme_Object scheme_true [1 ] ; 
Scheme_Object scheme_false [1 ] ; 
Scheme_Object * scheme_not_prim ; 
Scheme_Object * scheme_eq_prim ; 
Scheme_Object * scheme_eqv_prim ; 
Scheme_Object * scheme_equal_prim ; 
static Scheme_Object * not_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * boolean_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * eq_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * eqv_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_prim (int argc , Scheme_Object * argv [] ) ; 
typedef struct Equal_Info {
  long depth ; 
  long car_depth ; 
  Scheme_Hash_Table * ht ; 
  Scheme_Object * recur ; 
}
Equal_Info ; 
static int is_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) ; 
static int vector_equal (Scheme_Object * vec1 , Scheme_Object * vec2 , Equal_Info * eql ) ; 
static int struct_equal (Scheme_Object * s1 , Scheme_Object * s2 , Equal_Info * eql ) ; 
void scheme_init_true_false (void ) {
  /* No conversion */
  scheme_true -> type = scheme_true_type ; 
  scheme_false -> type = scheme_false_type ; 
  scheme_void -> type = scheme_void_type ; 
}
void scheme_init_bool (Scheme_Env * env ) {
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_not_prim , sizeof (scheme_not_prim ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_eq_prim , sizeof (scheme_eq_prim ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_eqv_prim , sizeof (scheme_eqv_prim ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_equal_prim , sizeof (scheme_equal_prim ) ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (not_prim , "not" , 1 , 1 , 1 ) ); 
  scheme_not_prim = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 16384 ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_add_global_constant ("not" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (boolean_p_prim , "boolean?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 16384 ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_add_global_constant ("boolean?" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (eq_prim , "eq?" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  scheme_eq_prim = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_add_global_constant ("eq?" , p , env ) ); 
  scheme_eqv_prim = FUNCCALL_AGAIN(scheme_make_folding_prim (eqv_prim , "eqv?" , 2 , 2 , 1 ) ); 
  FUNCCALL_AGAIN(scheme_add_global_constant ("eqv?" , scheme_eqv_prim , env ) ); 
  scheme_equal_prim = FUNCCALL_AGAIN(scheme_make_prim_w_arity (equal_prim , "equal?" , 2 , 2 ) ); 
  FUNCCALL_EMPTY(scheme_add_global_constant ("equal?" , scheme_equal_prim , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * not_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return (((argv [0 ] ) == (scheme_false ) ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * boolean_p_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return ((((argv [0 ] ) == (scheme_true ) ) || ((argv [0 ] ) == (scheme_false ) ) ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * eq_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return (((argv [0 ] ) == (argv [1 ] ) ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * eqv_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return (scheme_eqv (argv [0 ] , argv [1 ] ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * equal_prim (int argc , Scheme_Object * argv [] ) {
  Equal_Info eql ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1)));
# define XfOrM7_COUNT (2)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql . depth = 1 ; 
  eql . car_depth = 1 ; 
  eql . ht = ((void * ) 0 ) ; 
  eql . recur = ((void * ) 0 ) ; 
  RET_VALUE_START ((FUNCCALL(SETUP_XfOrM7(_), is_equal (argv [0 ] , argv [1 ] , & eql ) )? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_eq (Scheme_Object * obj1 , Scheme_Object * obj2 ) {
  /* No conversion */
  return ((obj1 ) == (obj2 ) ) ; 
}
__xform_nongcing__ static inline int double_eqv (double a , double b ) {
  /* No conversion */
  if (a != b ) {
    if (isnan (a ) ) {
      if (isnan (b ) )
        return 1 ; 
    }
    return 0 ; 
  }
  if (a == 0.0 ) {
    if (b == 0.0 ) {
      return scheme_minus_zero_p (a ) == scheme_minus_zero_p (b ) ; 
    }
  }
  return 1 ; 
}
int scheme_eqv (Scheme_Object * obj1 , Scheme_Object * obj2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if (((obj1 ) == (obj2 ) ) )
    return 1 ; 
  t1 = ((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ; 
  t2 = ((((long ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ; 
  if (((Scheme_Type ) (t1 ) != (Scheme_Type ) (t2 ) ) ) {
    return 0 ; 
  }
  else if (t1 == scheme_double_type ) {
    return double_eqv ((((Scheme_Double * ) (obj1 ) ) -> double_val ) , (((Scheme_Double * ) (obj2 ) ) -> double_val ) ) ; 
  }
  else if (t1 == scheme_bignum_type )
    return scheme_bignum_eq (obj1 , obj2 ) ; 
  else if (t1 == scheme_rational_type )
    return scheme_rational_eq (obj1 , obj2 ) ; 
  else if (t1 == scheme_complex_type ) {
    Scheme_Complex * c1 = (Scheme_Complex * ) obj1 ; 
    Scheme_Complex * c2 = (Scheme_Complex * ) obj2 ; 
    return scheme_eqv (c1 -> r , c2 -> r ) && scheme_eqv (c1 -> i , c2 -> i ) ; 
  }
  else if (t1 == scheme_char_type )
    return (((Scheme_Small_Object * ) (obj1 ) ) -> u . char_val ) == (((Scheme_Small_Object * ) (obj2 ) ) -> u . char_val ) ; 
  else return 0 ; 
}
int scheme_equal (Scheme_Object * obj1 , Scheme_Object * obj2 ) {
  Equal_Info eql ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1)));
# define XfOrM18_COUNT (2)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql . depth = 1 ; 
  eql . car_depth = 1 ; 
  eql . ht = ((void * ) 0 ) ; 
  eql . recur = ((void * ) 0 ) ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM18(_), is_equal (obj1 , obj2 , & eql ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * union_find (Scheme_Object * obj1 , Scheme_Hash_Table * ht ) {
  Scheme_Object * v , * prev = obj1 , * prev_prev = obj1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(ht, 1), PUSH(obj1, 2), PUSH(prev, 3), PUSH(prev_prev, 4)));
# define XfOrM19_COUNT (5)
# define SETUP_XfOrM19(x) SETUP(XfOrM19_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  while (1 ) {
#   define XfOrM24_COUNT (0+XfOrM19_COUNT)
#   define SETUP_XfOrM24(x) SETUP_XfOrM19(x)
    v = FUNCCALL(SETUP_XfOrM24(_), scheme_hash_get (ht , prev ) ); 
    if (v ) {
      prev_prev = prev ; 
      prev = v ; 
    }
    else break ; 
  }
  while (obj1 != prev_prev ) {
#   define XfOrM21_COUNT (0+XfOrM19_COUNT)
#   define SETUP_XfOrM21(x) SETUP_XfOrM19(x)
    v = FUNCCALL(SETUP_XfOrM21(_), scheme_hash_get (ht , obj1 ) ); 
    FUNCCALL(SETUP_XfOrM21(_), scheme_hash_set (ht , obj1 , prev ) ); 
    obj1 = v ; 
  }
  RET_VALUE_START (prev ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int union_check (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) {
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(obj2, 0), PUSH(obj1, 1), PUSH(eql, 2)));
# define XfOrM26_COUNT (3)
# define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (eql -> depth < 50 ) {
    eql -> depth += 2 ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  else {
    Scheme_Hash_Table * ht = eql -> ht ; 
    BLOCK_SETUP((PUSH(ht, 0+XfOrM26_COUNT)));
#   define XfOrM27_COUNT (1+XfOrM26_COUNT)
#   define SETUP_XfOrM27(x) SETUP(XfOrM27_COUNT)
    if (! ht ) {
#     define XfOrM28_COUNT (0+XfOrM27_COUNT)
#     define SETUP_XfOrM28(x) SETUP_XfOrM27(x)
      ht = FUNCCALL(SETUP_XfOrM28(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      eql -> ht = ht ; 
    }
    obj1 = FUNCCALL(SETUP_XfOrM27(_), union_find (obj1 , ht ) ); 
    obj2 = FUNCCALL(SETUP_XfOrM27(_), union_find (obj2 , ht ) ); 
    if (((obj1 ) == (obj2 ) ) )
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    FUNCCALL_EMPTY(scheme_hash_set (ht , obj2 , obj1 ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * equal_k () {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * v1 = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * v2 = (Scheme_Object * ) p -> ku . k . p2 ; 
  Equal_Info * eql = (Equal_Info * ) p -> ku . k . p3 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  return is_equal (v1 , v2 , eql ) ? scheme_true : scheme_false ; 
}
static Scheme_Object * equal_recur (int argc , Scheme_Object * * argv , Scheme_Object * prim ) {
  /* No conversion */
  Equal_Info * eql = (Equal_Info * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
  return (is_equal (argv [0 ] , argv [1 ] , eql ) ? scheme_true : scheme_false ) ; 
}
static int is_equal_overflow (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) {
  Scheme_Thread * p = scheme_current_thread ; 
  Equal_Info * eql2 ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(obj2, 0), PUSH(eql2, 1), PUSH(obj1, 2), PUSH(v, 3), PUSH(p, 4), PUSH(eql, 5)));
# define XfOrM32_COUNT (6)
# define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql2 = NULLED_OUT ; 
  v = NULLED_OUT ; 
  eql2 = (Equal_Info * ) FUNCCALL(SETUP_XfOrM32(_), GC_malloc (sizeof (Equal_Info ) ) ); 
  (memcpy (eql2 , eql , sizeof (Equal_Info ) ) ) ; 
  p -> ku . k . p1 = (void * ) obj1 ; 
  p -> ku . k . p2 = (void * ) obj2 ; 
  p -> ku . k . p3 = (void * ) eql2 ; 
  v = FUNCCALL(SETUP_XfOrM32(_), scheme_handle_stack_overflow (equal_k ) ); 
  (memcpy (eql , eql2 , sizeof (Equal_Info ) ) ) ; 
  RET_VALUE_START ((! (((v ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int is_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) {
  static int equal_counter = 20 ; 
  Scheme_Config * __funcarg7 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(obj2, 0), PUSH(obj1, 1), PUSH(eql, 2)));
# define XfOrM33_COUNT (3)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  top : if ((scheme_eqv (obj1 , obj2 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) != (Scheme_Type ) (((((long ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ) ) ) {
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM85_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM85(x) SETUP_XfOrM33(x)
    if (! -- equal_counter ) {
#     define XfOrM88_COUNT (0+XfOrM85_COUNT)
#     define SETUP_XfOrM88(x) SETUP_XfOrM85(x)
      equal_counter = 20 ; 
      {
#       define XfOrM90_COUNT (0+XfOrM88_COUNT)
#       define SETUP_XfOrM90(x) SETUP_XfOrM88(x)
        if ((scheme_fuel_counter ) <= 0 ) {
#         define XfOrM91_COUNT (0+XfOrM90_COUNT)
#         define SETUP_XfOrM91(x) SETUP_XfOrM90(x)
          FUNCCALL(SETUP_XfOrM91(_), scheme_out_of_fuel () ); 
        }
      }
      ; 
      {
        unsigned long _stk_pos ; 
#       define XfOrM89_COUNT (0+XfOrM88_COUNT)
#       define SETUP_XfOrM89(x) SETUP_XfOrM88(x)
        _stk_pos = (unsigned long ) & _stk_pos ; 
        if (((_stk_pos ) < (scheme_stack_boundary ) ) )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
    }
    if ((eql -> car_depth > 2 ) || ! FUNCCALL(SETUP_XfOrM85(_), scheme_is_list (obj1 ) )) {
#     define XfOrM87_COUNT (0+XfOrM85_COUNT)
#     define SETUP_XfOrM87(x) SETUP_XfOrM85(x)
      if (FUNCCALL(SETUP_XfOrM87(_), union_check (obj1 , obj2 , eql ) ))
        RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    eql -> car_depth += 2 ; 
    if (FUNCCALL(SETUP_XfOrM85(_), is_equal ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . car ) , eql ) )) {
      eql -> car_depth -= 2 ; 
      obj1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . cdr ) ; 
      obj2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . cdr ) ; 
      goto top ; 
    }
    else RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ) {
#   define XfOrM79_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM79(x) SETUP_XfOrM33(x)
    if (! -- equal_counter ) {
#     define XfOrM81_COUNT (0+XfOrM79_COUNT)
#     define SETUP_XfOrM81(x) SETUP_XfOrM79(x)
      equal_counter = 20 ; 
      {
#       define XfOrM83_COUNT (0+XfOrM81_COUNT)
#       define SETUP_XfOrM83(x) SETUP_XfOrM81(x)
        if ((scheme_fuel_counter ) <= 0 ) {
#         define XfOrM84_COUNT (0+XfOrM83_COUNT)
#         define SETUP_XfOrM84(x) SETUP_XfOrM83(x)
          FUNCCALL(SETUP_XfOrM84(_), scheme_out_of_fuel () ); 
        }
      }
      ; 
      {
        unsigned long _stk_pos ; 
#       define XfOrM82_COUNT (0+XfOrM81_COUNT)
#       define SETUP_XfOrM82(x) SETUP_XfOrM81(x)
        _stk_pos = (unsigned long ) & _stk_pos ; 
        if (((_stk_pos ) < (scheme_stack_boundary ) ) )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
    }
    if (FUNCCALL(SETUP_XfOrM79(_), union_check (obj1 , obj2 , eql ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    if (FUNCCALL(SETUP_XfOrM79(_), is_equal ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . car ) , eql ) )) {
      obj1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . cdr ) ; 
      obj2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . cdr ) ; 
      goto top ; 
    }
    else RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
#   define XfOrM74_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM74(x) SETUP_XfOrM33(x)
    if (! -- equal_counter ) {
#     define XfOrM75_COUNT (0+XfOrM74_COUNT)
#     define SETUP_XfOrM75(x) SETUP_XfOrM74(x)
      equal_counter = 20 ; 
      {
#       define XfOrM77_COUNT (0+XfOrM75_COUNT)
#       define SETUP_XfOrM77(x) SETUP_XfOrM75(x)
        if ((scheme_fuel_counter ) <= 0 ) {
#         define XfOrM78_COUNT (0+XfOrM77_COUNT)
#         define SETUP_XfOrM78(x) SETUP_XfOrM77(x)
          FUNCCALL(SETUP_XfOrM78(_), scheme_out_of_fuel () ); 
        }
      }
      ; 
      {
        unsigned long _stk_pos ; 
#       define XfOrM76_COUNT (0+XfOrM75_COUNT)
#       define SETUP_XfOrM76(x) SETUP_XfOrM75(x)
        _stk_pos = (unsigned long ) & _stk_pos ; 
        if (((_stk_pos ) < (scheme_stack_boundary ) ) )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
    }
    if (FUNCCALL(SETUP_XfOrM74(_), union_check (obj1 , obj2 , eql ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(vector_equal (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) >= scheme_unix_path_type ) && (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) <= scheme_windows_path_type ) ) ) {
    int l1 , l2 ; 
#   define XfOrM73_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM73(x) SETUP_XfOrM33(x)
    l1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . byte_str_val . tag_val ) ; 
    l2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . byte_str_val . tag_val ) ; 
    RET_VALUE_START (((l1 == l2 ) && ! (memcmp ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . byte_str_val . string_val ) , l1 ) ) ) ) RET_VALUE_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
    int l1 , l2 ; 
#   define XfOrM72_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM72(x) SETUP_XfOrM33(x)
    l1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . char_str_val . tag_val ) ; 
    l2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . char_str_val . tag_val ) ; 
    RET_VALUE_START (((l1 == l2 ) && ! (memcmp ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . char_str_val . string_val ) , l1 * sizeof (mzchar ) ) ) ) ) RET_VALUE_END ; 
  }
  else if ((((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
    Scheme_Struct_Type * st1 , * st2 ; 
    Scheme_Object * procs1 , * procs2 ; 
    BLOCK_SETUP((PUSH(st1, 0+XfOrM33_COUNT), PUSH(st2, 1+XfOrM33_COUNT), PUSH(procs1, 2+XfOrM33_COUNT)));
#   define XfOrM56_COUNT (3+XfOrM33_COUNT)
#   define SETUP_XfOrM56(x) SETUP(XfOrM56_COUNT)
    st1 = NULLED_OUT ; 
    st2 = NULLED_OUT ; 
    procs1 = NULLED_OUT ; 
    procs2 = NULLED_OUT ; 
    st1 = (((Scheme_Structure * ) obj1 ) -> stype ) ; 
    st2 = (((Scheme_Structure * ) obj2 ) -> stype ) ; 
    procs1 = (scheme_struct_type_property_ref (scheme_equal_property , (Scheme_Object * ) st1 ) ) ; 
    if (procs1 && (st1 != st2 ) ) {
#     define XfOrM71_COUNT (0+XfOrM56_COUNT)
#     define SETUP_XfOrM71(x) SETUP_XfOrM56(x)
      procs2 = (scheme_struct_type_property_ref (scheme_equal_property , (Scheme_Object * ) st2 ) ) ; 
      if (! procs2 || ! (((((Scheme_Vector * ) (procs1 ) ) -> els ) [0 ] ) == ((((Scheme_Vector * ) (procs2 ) ) -> els ) [0 ] ) ) )
        procs1 = ((void * ) 0 ) ; 
    }
    if (procs1 ) {
      Scheme_Object * a [3 ] , * recur ; 
      Equal_Info * eql2 ; 
      BLOCK_SETUP((PUSH(recur, 0+XfOrM56_COUNT), PUSH(eql2, 1+XfOrM56_COUNT), PUSHARRAY(a, 3, 2+XfOrM56_COUNT)));
#     define XfOrM64_COUNT (5+XfOrM56_COUNT)
#     define SETUP_XfOrM64(x) SETUP(XfOrM64_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      a[2] = NULLED_OUT ; 
      recur = NULLED_OUT ; 
      eql2 = NULLED_OUT ; 
      if (! -- equal_counter ) {
#       define XfOrM67_COUNT (0+XfOrM64_COUNT)
#       define SETUP_XfOrM67(x) SETUP_XfOrM64(x)
        equal_counter = 20 ; 
        {
#         define XfOrM69_COUNT (0+XfOrM67_COUNT)
#         define SETUP_XfOrM69(x) SETUP_XfOrM67(x)
          if ((scheme_fuel_counter ) <= 0 ) {
#           define XfOrM70_COUNT (0+XfOrM69_COUNT)
#           define SETUP_XfOrM70(x) SETUP_XfOrM69(x)
            FUNCCALL(SETUP_XfOrM70(_), scheme_out_of_fuel () ); 
          }
        }
        ; 
        {
          unsigned long _stk_pos ; 
#         define XfOrM68_COUNT (0+XfOrM67_COUNT)
#         define SETUP_XfOrM68(x) SETUP_XfOrM67(x)
          _stk_pos = (unsigned long ) & _stk_pos ; 
          if (((_stk_pos ) < (scheme_stack_boundary ) ) )
            RET_VALUE_START (FUNCCALL(SETUP_XfOrM68(_), is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_END ; 
        }
      }
      if (FUNCCALL(SETUP_XfOrM64(_), union_check (obj1 , obj2 , eql ) ))
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      if (eql -> recur ) {
        recur = eql -> recur ; 
        eql2 = (Equal_Info * ) ((Scheme_Primitive_Closure * ) recur ) -> val [0 ] ; 
      }
      else {
#       define XfOrM65_COUNT (0+XfOrM64_COUNT)
#       define SETUP_XfOrM65(x) SETUP_XfOrM64(x)
        eql2 = (Equal_Info * ) FUNCCALL(SETUP_XfOrM65(_), GC_malloc (sizeof (Equal_Info ) ) ); 
        a [0 ] = (Scheme_Object * ) eql2 ; 
        recur = FUNCCALL(SETUP_XfOrM65(_), scheme_make_prim_closure_w_arity (equal_recur , 1 , a , "equal?/recur" , 2 , 2 ) ); 
        eql -> recur = recur ; 
      }
      (memcpy (eql2 , eql , sizeof (Equal_Info ) ) ) ; 
      a [0 ] = obj1 ; 
      a [1 ] = obj2 ; 
      a [2 ] = recur ; 
      procs1 = (((Scheme_Vector * ) (procs1 ) ) -> els ) [1 ] ; 
      recur = FUNCCALL(SETUP_XfOrM64(_), scheme_do_eval (procs1 , 3 , a , 1 ) ); 
      (memcpy (eql , eql2 , sizeof (Equal_Info ) ) ) ; 
      RET_VALUE_START ((! (((recur ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
    }
    else if (st1 != st2 ) {
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    else {
      Scheme_Object * insp ; 
      BLOCK_SETUP((PUSH(insp, 0+XfOrM56_COUNT)));
#     define XfOrM57_COUNT (1+XfOrM56_COUNT)
#     define SETUP_XfOrM57(x) SETUP(XfOrM57_COUNT)
      insp = NULLED_OUT ; 
      insp = (__funcarg7 = FUNCCALL(SETUP_XfOrM57(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg7 , MZCONFIG_INSPECTOR ) )) ; 
      if (FUNCCALL(SETUP_XfOrM57(_), scheme_inspector_sees_part (obj1 , insp , - 2 ) )&& FUNCCALL(SETUP_XfOrM57(_), scheme_inspector_sees_part (obj2 , insp , - 2 ) )) {
#       define XfOrM58_COUNT (0+XfOrM57_COUNT)
#       define SETUP_XfOrM58(x) SETUP_XfOrM57(x)
        if (! -- equal_counter ) {
#         define XfOrM59_COUNT (0+XfOrM58_COUNT)
#         define SETUP_XfOrM59(x) SETUP_XfOrM58(x)
          equal_counter = 20 ; 
          {
#           define XfOrM61_COUNT (0+XfOrM59_COUNT)
#           define SETUP_XfOrM61(x) SETUP_XfOrM59(x)
            if ((scheme_fuel_counter ) <= 0 ) {
#             define XfOrM62_COUNT (0+XfOrM61_COUNT)
#             define SETUP_XfOrM62(x) SETUP_XfOrM61(x)
              FUNCCALL(SETUP_XfOrM62(_), scheme_out_of_fuel () ); 
            }
          }
          ; 
          {
            unsigned long _stk_pos ; 
#           define XfOrM60_COUNT (0+XfOrM59_COUNT)
#           define SETUP_XfOrM60(x) SETUP_XfOrM59(x)
            _stk_pos = (unsigned long ) & _stk_pos ; 
            if (((_stk_pos ) < (scheme_stack_boundary ) ) )
              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
          }
        }
        if (FUNCCALL(SETUP_XfOrM58(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(struct_equal (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
      else RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {
#   define XfOrM53_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM53(x) SETUP_XfOrM33(x)
    {
#     define XfOrM54_COUNT (0+XfOrM53_COUNT)
#     define SETUP_XfOrM54(x) SETUP_XfOrM53(x)
      if ((scheme_fuel_counter ) <= 0 ) {
#       define XfOrM55_COUNT (0+XfOrM54_COUNT)
#       define SETUP_XfOrM55(x) SETUP_XfOrM54(x)
        FUNCCALL(SETUP_XfOrM55(_), scheme_out_of_fuel () ); 
      }
    }
    ; 
    if (FUNCCALL(SETUP_XfOrM53(_), union_check (obj1 , obj2 , eql ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    obj1 = (((Scheme_Small_Object * ) (obj1 ) ) -> u . ptr_val ) ; 
    obj2 = (((Scheme_Small_Object * ) (obj2 ) ) -> u . ptr_val ) ; 
    goto top ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
#   define XfOrM48_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM48(x) SETUP_XfOrM33(x)
    if (! -- equal_counter ) {
#     define XfOrM49_COUNT (0+XfOrM48_COUNT)
#     define SETUP_XfOrM49(x) SETUP_XfOrM48(x)
      equal_counter = 20 ; 
      {
#       define XfOrM51_COUNT (0+XfOrM49_COUNT)
#       define SETUP_XfOrM51(x) SETUP_XfOrM49(x)
        if ((scheme_fuel_counter ) <= 0 ) {
#         define XfOrM52_COUNT (0+XfOrM51_COUNT)
#         define SETUP_XfOrM52(x) SETUP_XfOrM51(x)
          FUNCCALL(SETUP_XfOrM52(_), scheme_out_of_fuel () ); 
        }
      }
      ; 
      {
        unsigned long _stk_pos ; 
#       define XfOrM50_COUNT (0+XfOrM49_COUNT)
#       define SETUP_XfOrM50(x) SETUP_XfOrM49(x)
        _stk_pos = (unsigned long ) & _stk_pos ; 
        if (((_stk_pos ) < (scheme_stack_boundary ) ) )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
    }
    if (FUNCCALL(SETUP_XfOrM48(_), union_check (obj1 , obj2 , eql ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_hash_table_equal_rec ((Scheme_Hash_Table * ) obj1 , (Scheme_Hash_Table * ) obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) {
#   define XfOrM43_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM43(x) SETUP_XfOrM33(x)
    if (! -- equal_counter ) {
#     define XfOrM44_COUNT (0+XfOrM43_COUNT)
#     define SETUP_XfOrM44(x) SETUP_XfOrM43(x)
      equal_counter = 20 ; 
      {
#       define XfOrM46_COUNT (0+XfOrM44_COUNT)
#       define SETUP_XfOrM46(x) SETUP_XfOrM44(x)
        if ((scheme_fuel_counter ) <= 0 ) {
#         define XfOrM47_COUNT (0+XfOrM46_COUNT)
#         define SETUP_XfOrM47(x) SETUP_XfOrM46(x)
          FUNCCALL(SETUP_XfOrM47(_), scheme_out_of_fuel () ); 
        }
      }
      ; 
      {
        unsigned long _stk_pos ; 
#       define XfOrM45_COUNT (0+XfOrM44_COUNT)
#       define SETUP_XfOrM45(x) SETUP_XfOrM44(x)
        _stk_pos = (unsigned long ) & _stk_pos ; 
        if (((_stk_pos ) < (scheme_stack_boundary ) ) )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
    }
    if (FUNCCALL(SETUP_XfOrM43(_), union_check (obj1 , obj2 , eql ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_hash_tree_equal_rec ((Scheme_Hash_Tree * ) obj1 , (Scheme_Hash_Tree * ) obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) ) {
#   define XfOrM38_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM38(x) SETUP_XfOrM33(x)
    if (! -- equal_counter ) {
#     define XfOrM39_COUNT (0+XfOrM38_COUNT)
#     define SETUP_XfOrM39(x) SETUP_XfOrM38(x)
      equal_counter = 20 ; 
      {
#       define XfOrM41_COUNT (0+XfOrM39_COUNT)
#       define SETUP_XfOrM41(x) SETUP_XfOrM39(x)
        if ((scheme_fuel_counter ) <= 0 ) {
#         define XfOrM42_COUNT (0+XfOrM41_COUNT)
#         define SETUP_XfOrM42(x) SETUP_XfOrM41(x)
          FUNCCALL(SETUP_XfOrM42(_), scheme_out_of_fuel () ); 
        }
      }
      ; 
      {
        unsigned long _stk_pos ; 
#       define XfOrM40_COUNT (0+XfOrM39_COUNT)
#       define SETUP_XfOrM40(x) SETUP_XfOrM39(x)
        _stk_pos = (unsigned long ) & _stk_pos ; 
        if (((_stk_pos ) < (scheme_stack_boundary ) ) )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
    }
    if (FUNCCALL(SETUP_XfOrM38(_), union_check (obj1 , obj2 , eql ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_bucket_table_equal_rec ((Scheme_Bucket_Table * ) obj1 , (Scheme_Bucket_Table * ) obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_wrap_chunk_type ) ) ) {
#   define XfOrM37_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM37(x) SETUP_XfOrM33(x)
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(vector_equal (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_resolved_module_path_type ) ) ) {
    obj1 = (((Scheme_Small_Object * ) (obj1 ) ) -> u . ptr_val ) ; 
    obj2 = (((Scheme_Small_Object * ) (obj2 ) ) -> u . ptr_val ) ; 
    goto top ; 
  }
  else {
    Scheme_Equal_Proc eqlp = scheme_type_equals [((((long ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ] ; 
#   define XfOrM34_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM34(x) SETUP_XfOrM33(x)
    if (eqlp ) {
#     define XfOrM35_COUNT (0+XfOrM34_COUNT)
#     define SETUP_XfOrM35(x) SETUP_XfOrM34(x)
      if (FUNCCALL(SETUP_XfOrM35(_), union_check (obj1 , obj2 , eql ) ))
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(eqlp (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
    }
    else RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int vector_equal (Scheme_Object * vec1 , Scheme_Object * vec2 , Equal_Info * eql ) {
  int i , len ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(eql, 0), PUSH(vec2, 1), PUSH(vec1, 2)));
# define XfOrM93_COUNT (3)
# define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  len = (((Scheme_Vector * ) (vec1 ) ) -> size ) ; 
  if (len != (((Scheme_Vector * ) (vec2 ) ) -> size ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  {
#   define XfOrM96_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM96(x) SETUP_XfOrM93(x)
    if ((scheme_fuel_counter ) <= 0 ) {
#     define XfOrM97_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM97(x) SETUP_XfOrM96(x)
      FUNCCALL(SETUP_XfOrM97(_), scheme_out_of_fuel () ); 
    }
  }
  ; 
  for (i = 0 ; i < len ; i ++ ) {
#   define XfOrM95_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM95(x) SETUP_XfOrM93(x)
    if (! FUNCCALL(SETUP_XfOrM95(_), is_equal ((((Scheme_Vector * ) (vec1 ) ) -> els ) [i ] , (((Scheme_Vector * ) (vec2 ) ) -> els ) [i ] , eql ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int struct_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) {
  Scheme_Structure * s1 , * s2 ; 
  int i ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(eql, 0), PUSH(s1, 1), PUSH(s2, 2)));
# define XfOrM98_COUNT (3)
# define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s1 = NULLED_OUT ; 
  s2 = NULLED_OUT ; 
  s1 = (Scheme_Structure * ) obj1 ; 
  s2 = (Scheme_Structure * ) obj2 ; 
  for (i = ((((Scheme_Structure * ) s1 ) -> stype ) -> num_slots ) ; i -- ; ) {
#   define XfOrM100_COUNT (0+XfOrM98_COUNT)
#   define SETUP_XfOrM100(x) SETUP_XfOrM98(x)
    if (! FUNCCALL(SETUP_XfOrM100(_), is_equal (s1 -> slots [i ] , s2 -> slots [i ] , eql ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_recur_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , void * cycle_info ) {
  /* No conversion */
  return is_equal (obj1 , obj2 , (Equal_Info * ) cycle_info ) ; 
}
Scheme_Object * scheme_make_true (void ) {
  /* No conversion */
  return scheme_true ; 
}
Scheme_Object * scheme_make_false (void ) {
  /* No conversion */
  return scheme_false ; 
}
